/***************************************************************************
 *   Copyright (C) 2005 by Ernest Nieto                                    *
 *   ernest.nieto@gmail.com                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "nmgdynamicwidgetcontainer.h"

/**
 * Contructor of the class
 * @param parent Qt's parent parameter
 * @param name Qt's name parameter
 * @return 
 */
NMGDynamicWidgetContainer::NMGDynamicWidgetContainer(QWidget *parent, const char *name)
 : QVBox(parent, name)
{
	current = 0;
}

/**
 * Destructor of the class
 * @return 
 */
NMGDynamicWidgetContainer::~NMGDynamicWidgetContainer()
{
}

/**
 * Adds a widget and makes it visible (if there was another widget added the other becomes hidden)
 * @param w QWidget to add
 */
void NMGDynamicWidgetContainer::add(QWidget * w)
{
	QPoint p;
	if(w->parent()!=this) w->reparent(this,p);
	if(current) current->hide();
	current = w;
	w->show();
}

/**
 * Removes the widget from the container (you'd better not use this function!)
 * If you only want to hide the widget, call w->hide()
 * @param w QWidget to remove
 */
void NMGDynamicWidgetContainer::remove(QWidget * w)
{
	w->hide();
	if(w->parent()==this) removeChild(w);
}

#include "nmgdynamicwidgetcontainer.moc"
