/***************************************************************************
 *   Copyright (C) 2005 by Ernest Nieto                                    *
 *   ernest.nieto@gmail.com                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef NMGMAINOPTIONSWIDGET_H
#define NMGMAINOPTIONSWIDGET_H

#include <qvariant.h>
#include <qpixmap.h>
#include <qwidget.h>

class QVBoxLayout;
class QHBoxLayout;
class QGridLayout;
class QSpacerItem;
class QGroupBox;
class QLabel;
class QPushButton;
class QComboBox;
class QLineEdit;


/**
@author Ernest Nieto
*/
class NMGMainOptionsWidget : public QWidget
{
Q_OBJECT
public:
    NMGMainOptionsWidget(QWidget *parent = 0, const char *name = 0, WFlags fl = 0 );

    ~NMGMainOptionsWidget();

public slots:
    void senderActivated(int index);
    
    void receiverActivated(int index);
    
private slots:
    void senderButtonClicked(); 
    
    void receiverButtonClicked(); 

signals:
    void senderSelected(QString);
    
    void receiverSelected(QString);

    void showHostInformation(QString);
                
private:
    void createWidgets();
    
    void connectWidgets();
    
private:
    QGroupBox* groupOptions;
    QLabel* lblProtocol;
    QPushButton* btnSender;
    QComboBox* comboProtocol;
    QLabel* lblAdressType;
    QComboBox* comboSender;
    QLabel* lblSender;
    QPushButton* btnReceiver;
    QComboBox* comboReceiver;
    QComboBox* comboAdressType;
    QLabel* lblReceiver;
    QGroupBox* groupConfiguration;
    QLabel* lblConfigurationFile;
    QLabel* lblConfigurationName;
    QLabel* lblConfigurationFileLabel;
    QLineEdit* txtConfigurationName;
    QPushButton* btnConfigurationLoad;
    QPushButton* btnConfigurationSave;
    QPushButton* btnConfigurationSaveAs;

protected:
    QGridLayout* NMGOptionsWidgetLayout;
    QSpacerItem* spacerH;
    QSpacerItem* spacerV;
    QGridLayout* groupOptionsLayout;
    QVBoxLayout* groupConfigurationLayout;
    QGridLayout* layoutNameFile;
    QHBoxLayout* layoutButtonsFile;

private:
    QPixmap image0;
        
};

#endif
