/***************************************************************************
 *   Copyright (C) 2005 by Ernest Nieto                                    *
 *   ernest.nieto@gmail.com                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "nmgmodulecontainerwidget.h"

#include "../../plugin/nmgmodulemanager.h"

#include <iostream>
using namespace std;

/**
 * Contructor of the class
 * @param parent Qt's parent parameter
 * @param name Qt'a name parameter
 * @return 
 */
NMGModuleContainerWidget::NMGModuleContainerWidget(QWidget *parent, const char *name)
 : QWidget(parent, name)
{

	layout = new QHBoxLayout(this,11,6);
	splitter = new QSplitter(this);
	splitter->setOrientation(QSplitter::Horizontal);
	
	listView = new NMGModuleListViewWidget(splitter);
	
	listView->setMaximumSize( QSize( 160, 32767 ) );

	dynamicContainer = new NMGDynamicWidgetContainer(splitter);
	layout->addWidget(splitter);
	
//	connect(NMGModuleRegister::getModuleRegister(),SIGNAL(moduleLoaded(NMGModule* )),this,SLOT(addModule(NMGModule* )));
	connect(listView,SIGNAL(moduleActivated(QString )),this,SLOT(moduleActivated(QString )));
	
// 	QValueList<NMGModule *> l = NMGModuleRegister::getModuleRegister()->getModuleList();
// 	for(QValueList<NMGModule *>::iterator it = l.begin(); it!=l.end(); ++it) addModule(*it);
}


/**
 * Destructor of the class
 * @return 
 */
NMGModuleContainerWidget::~NMGModuleContainerWidget()
{
	//Qt will destroy all the widgets
}

/**
 * Adds a module into the module container
 * @param m Module to add
 */
void NMGModuleContainerWidget::addModule(NMGModule * m)
{
	listView->addModule(m->getName(),m->getModuleCapabilities());
}


/**
 * Method to call when there has been selected a module and it has to be shown its widget
 * @param s Name of the module
 */
void NMGModuleContainerWidget::moduleActivated(QString name)
{
	NMModule * mod = NMGModuleManager::self()->getModule(name);
	if(mod)
	{
		cout << "CVADADADADA" << endl;
	}
	else cerr << "[warning] The module " << name << " is not loaded into memory!"<< endl;
	
/*	NMGModule * mod = NMGModuleRegister::getModuleRegister()->getModule(s);
	if(mod)
	{
		QWidget * w = mod->getWidget();
		if(w) dynamicContainer->add(w);
		else cerr << "Couldn't create the widget for the module " << s << endl;
	}
	else cerr << "[warning] The module " << s << " is not loaded into memory!"<< endl;*/
	
}


#include "nmgmodulecontainerwidget.moc"
