/***************************************************************************
 *   Copyright (C) 2005 by Ernest Nieto                                    *
 *   ernest.nieto@gmail.com                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef NMGMODULECONTAINERWIDGET_H
#define NMGMODULECONTAINERWIDGET_H

#include <qwidget.h>
#include <qlayout.h>
#include <qsplitter.h>
#include <qvaluelist.h>

#include "nmgmodulelistviewwidget.h"
#include "nmgdynamicwidgetcontainer.h"
#include "../../plugin/nmgmodule.h"

/**
@author Ernest Nieto
*/
class NMGModuleContainerWidget : public QWidget
{
Q_OBJECT
public:
    NMGModuleContainerWidget(QWidget *parent = 0, const char *name = 0);

    ~NMGModuleContainerWidget();

public slots:
    void addModule(NMGModule * m);
    void moduleActivated(QString s);
    
private:
    NMGModuleListViewWidget * listView;
    NMGDynamicWidgetContainer * dynamicContainer;
    QHBoxLayout * layout;
    QSplitter * splitter;

};

#endif
