/***************************************************************************
 *   Copyright (C) 2005 by Ernest Nieto                                    *
 *   ernest.nieto@gmail.com                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "nmgmodulelistviewitem.h"

#include <qpixmap.h>

#include <iostream>
using namespace std;

/**
 * Constructor of the class
 * @param parentList List parent of the list item
 * @param parent Qt's parent parameter
 * @param name Qt's name parameter
 * @return 
 */
NMGModuleListViewItem::NMGModuleListViewItem (QListView * parentList, QObject *parent, const char *name)
 : QObject(parent, name), QListViewItem(parentList)
{
	QPixmap pixmap("folder.png","PNG");
	setPixmap(0,pixmap);
}

/**
 * Constructor of the class
 * @param parentListItem List Item parent of the list item
 * @param parent Qt's parent parameter
 * @param name Qt's name parameter
 * @return 
 */
NMGModuleListViewItem::NMGModuleListViewItem (QListViewItem * parentListItem, QObject *parent, const char *name)
 : QObject(parent, name), QListViewItem(parentListItem)
{
}


/**
 * Destructor of the class
 * @return 
 */
NMGModuleListViewItem::~NMGModuleListViewItem()
{
}

/**
 * Sets the icon of the capability
 * @param capabilityName 
 */
void NMGModuleListViewItem::setCapabilityIcon(QString capabilityName)
{
	QPixmap pixmap(capabilityName + ".png","PNG");
	setPixmap(0,pixmap);	
}

#include "nmgmodulelistviewitem.moc"
