/***************************************************************************
 *   Copyright (C) 2005 by Ernest Nieto                                    *
 *   ernest.nieto@gmail.com                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef NMGMODULELISTVIEWWIDGET_H
#define NMGMODULELISTVIEWWIDGET_H

#include <qlistview.h>
#include <qmap.h>
#include <qpopupmenu.h>

#include "nmgmodulelistviewitem.h"

#include "../../plugin/nmgmodule.h"
#include "../../plugin/nmgmodulemanager.h"

#define QMAP_MODULE QMap<QString,NMGModuleListViewItem *>

/**
@author Ernest Nieto
*/
class NMGModuleListViewWidget : public QListView
{
Q_OBJECT
public:
    NMGModuleListViewWidget(QWidget *parent = 0, const char *name = 0);

    ~NMGModuleListViewWidget();

    void addCapability(QString capabilityName);
    
public slots:
    void addModule(QString moduleName, QString capabilityName);
    
    void newModule(NMGModule *);
    
    void moduleSelected(QString s);
    
    void returnPressed ( QListViewItem * );
    
    void spacePressed ( QListViewItem * );
    
    void rightButtonPressed( QListViewItem *, const QPoint &, int );
    
    void mouseButtonClicked ( int button, QListViewItem * item, const QPoint & pos, int c );
    
    void menuCreateInstance();
    
    void menuUnloadModule();
    
    void menuLoadModule();
    
signals:
    void moduleActivated(QString s);
    void createInstaceModule(const QString & s);
    void unloadModule(QString s);
    void loadNewModule(QString path);
    
private:
    void loadExistingModules();
    
    QString getModuleName(NMModule * m);
    
private:
    QMap<QString,NMGModuleListViewItem *> * moduleMap;
    QMap<QString,NMGModuleListViewItem *> * map;
    QPopupMenu menu;
    int idMenuCreateInstance;
    int idMenuUnloadModule;
};

#endif
