/***************************************************************************
 *   Copyright (C) 2005 by Ernest Nieto                                    *
 *   ernest.nieto@gmail.com                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "nmgpreferenceswidget.h"

#include "nmgpreferencesbasewidget.h"

#include "nmgpreferencesmodulewidget.h"

#include <qlayout.h>
#include <qtabwidget.h>
#include <qlineedit.h>
#include <qspinbox.h>
#include <qpushbutton.h>
#include <qradiobutton.h>

#include <iostream>
using namespace std;


/**
 * Constructor of the class
 * @param parent 
 * @param name 
 * @return 
 */
NMGPreferencesWidget::NMGPreferencesWidget(QWidget *parent, const char *name)
 : QWidget(parent, name, Qt::WType_Dialog | Qt::WShowModal)
{
	QHBoxLayout * layout = new QHBoxLayout(this,0,0);
	widget = new NMGPreferencesBaseWidget(this,"baseWidget");
	layout->addWidget(widget);
	connect(widget->buttonOk,SIGNAL(clicked()),this,SLOT(accept()));
	connect(widget->buttonCancel,SIGNAL(clicked()),this,SLOT(reject()));
	connect(widget->btnSelectPlugins,SIGNAL(clicked()),this,SLOT(showModulesToLoadWidget()));

}


/**
 * Destroyer of the class
 * @return 
 */
NMGPreferencesWidget::~NMGPreferencesWidget()
{
}

void NMGPreferencesWidget::hideEvent ( QHideEvent * )
{
cout << "NMGPreferencesWidget::hideEvent " << endl;
}

/**
 * Ok button clicked
 */
void NMGPreferencesWidget::accept()
{
cout << "NMGPreferencesWidget::accept" << endl;
	//setHidden(true);
	close();
}

/**
 * Cancel button clicked
 */
void NMGPreferencesWidget::reject()
{
cout << "NMGPreferencesWidget::reject" << endl;
	//setHidden(true);
	close();
}

void NMGPreferencesWidget::setNetMeterPort(int port)
{
	widget->spinBoxNetMeterPort->setValue(port);
}

void NMGPreferencesWidget::setConfigurationDirectory(QString dir)
{
	widget->txtConfDirectoryPath->setText(dir);
}

void NMGPreferencesWidget::setResultDirectory(QString dir)
{
	widget->txtResultDirectoryPath->setText(dir);
}

void NMGPreferencesWidget::showModulesToLoadWidget()
{
	NMGPreferencesModuleWidget * modulesToLoadWidget = new NMGPreferencesModuleWidget(widget,"modulesToLoadWidget",Qt::WType_Dialog | Qt::WShowModal);
	modulesToLoadWidget->show();
}

void NMGPreferencesWidget::updateWidgetsFromValues()
{

}

void NMGPreferencesWidget::updateDiskFromWidget()
{

}


#include "nmgpreferenceswidget.moc"
