/***************************************************************************
 *   Copyright (C) 2005 by Ernest Nieto                                    *
 *   ernest.nieto@gmail.com                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "nmgtaskwidget.h"

#include <iostream>
using namespace std;


NMGTaskWidget::NMGTaskWidget(QWidget *parent, const char *name)
 : QWidget(parent, name)
{
	layout = new QHBoxLayout(this,0,0);

	label = new QLabel("Task Name",this);
	layout->addWidget(label);
	
	bar = new QProgressBar(this);
	bar->setPercentageVisible(true);
	bar->setProgress(0,MAXPROGRESS);
	bar->setMaximumWidth(MAXWIDTHBAR);
	bar->setMinimumWidth(MINWIDTHBAR);
	layout->addWidget(bar);
}


NMGTaskWidget::~NMGTaskWidget()
{
}

void NMGTaskWidget::mousePressEvent ( QMouseEvent * e )
{
	if(e->button()==LeftButton)
		cout << "S'hauria de mostrar info (si escau) sobre la taska amb id " << id << endl;
	
}

void NMGTaskWidget::setToolTip(QString toolTip)
{
	QToolTip::add(bar,toolTip);
}

void NMGTaskWidget::setId(int i)
{
	id = i;
}

int NMGTaskWidget::getId()
{
	return id;
}

void NMGTaskWidget::setName(QString s)
{
	label->setText(s);
	setToolTip(s);
}

void NMGTaskWidget::advance()
{
	bar->setProgress(bar->progress()+1);
}


#include "nmgtaskwidget.moc"
