/***************************************************************************
 *   Copyright (C) 2005 by Pau Capella                                     *
 *   pcapella@ac.upc.edu                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef MESSAGEBAR_H
#define MESSAGEBAR_H

#include <qwidget.h>
#include <qlabel.h>
#include <qpixmap.h>
#include "popupmessage.h"

/**
	@author Pau Capella <pcapella@ac.upc.edu>
	@brief Print popup message
*/
class MessageBar : public QWidget
{
Q_OBJECT

public:
	MessageBar( PopupMessage *popupmessage, QWidget *parent, const char *name = 0);

	static void longMessage( const QString &text);
	static void longMessage( const QString &text, const QPixmap &pixmap);
	static void shortMessage( const QString &text);

protected:
	static MessageBar *self();
	PopupMessage *popupMessage() { return m_popupmessage; }

private:
	QLabel *m_mainTextLabel;
	PopupMessage *m_popupmessage;
	static MessageBar *m_instance;	
};

#endif
