/***************************************************************************
 *   Copyright (C) 2005 by Ernest Nieto                                    *
 *   ernest.nieto@gmail.com                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifdef HAVE_CONFIG_H
	#include <config.h>
#endif

#include "nmgmain.h"
#include "plugin/nmgmodulemanager.h"

#include <iostream>
using namespace std;


/**
 * Loads the modules
 */
void NMGMain::loadModules()
{
	moduleManager = NMGModuleManager::self();
	moduleManager->setLoadingModulesStartup(true);
	
	/* Quan estiguin tots a un directori es podrá fer directament 
		moduleManager->loadAllModules("/modules"); /o el path que sigui
	*/
	
// Aix s'ha de canviar, aix s una cutrada!
#ifdef DEVEL
	if(moduleManager->loadModule("plugin/libnmgtrace/.libs/libnmgtrace.so")==0)
		cout << "Module NMTrace loaded" << endl;
	else cerr << "Error while loading NMTrace module" << endl;
	
	if(moduleManager->loadModule("plugin/utils/.libs/libnmgsendfile.so")==0)
		cout << "Module Send File loaded" << endl;
	else cerr << "Error while loading SendFile module" << endl;

	if(moduleManager->loadModule("plugin/libnmgplugintest/.libs/libnmgplugintest.so")==0)
		cout << "Module NMPluginTest loaded" << endl;
	else cerr << "Error while loading NMPluginTest module" << endl;
	
	if(moduleManager->loadModule("plugin/libnmgexemple/.libs/libnmgexemple.so")==0)
		cout << "Module NMGExemple loaded" << endl;
	else cerr << "Error while loading NMGExemple module" << endl;
	
	if(moduleManager->loadModule("plugin/libnmgmgen/.libs/libnmgmgen.so")==0)
		cout << "Module MGEN loaded" << endl;
	else cerr << "Error while loading MGEN module" << endl;

	if(moduleManager->loadModule("plugin/libnmgoreneta/.libs/libnmgoreneta.so")==0)
		cout << "Module Oreneta loaded" << endl;
	else cerr << "Error while loading Oreneta module" << endl;

	if(moduleManager->loadModule("plugin/libnmgexemplesubscriptor/.libs/libnmgexemplesubscriptor.so")==0)
		cout << "Exemple Subscriptor module loaded" << endl;
	else cerr << "Error while loading Exemple Subscriptor module" << endl;

	if(moduleManager->loadModule("plugin/libnmgexemplesubscriptor/.libs/libnmgexemplesubscripted.so")==0)
		cout << "Exemple Subscripted module loaded" << endl;
	else cerr << "Error while loading Exemple Subscripted module" << endl;

	if(moduleManager->loadModule("plugin/libnmgexemplerequest/.libs/libnmgexemplerequest.so")==0)
		cout << "Exemple Request module loaded" << endl;
	else cerr << "Error while loading Exemple Request module" << endl;

	if(moduleManager->loadModule("plugin/libnmgexemplerequest/.libs/libnmgexempleadder.so")==0)
		cout << "Exemple Adder module loaded" << endl;
	else cerr << "Error while loading Exemple Adder module" << endl;

	if(moduleManager->loadModule("plugin/libnmggraph/.libs/libnmggraph.so")==0)
		cout << "Graph module loaded" << endl;
	else cerr << "Error while loading Graph module" << endl;

	if(moduleManager->loadModule("plugin/libnmgsnooper/.libs/libnmgsnooper.so")==0)
		cout << "snooper module loaded" << endl;
	else cerr << "Error while loading Snooper module" << endl;

	if(moduleManager->loadModule("plugin/libnmgconverter/.libs/libnmgconverter.so")==0)
		cout << "snooper module loaded" << endl;
	else cerr << "Error while loading Snooper module" << endl;
#else
	moduleManager->loadAllModules(PLUGIN_DIR);
	cerr << "No DEVEL" << endl;
#endif
	moduleManager->setLoadingModulesStartup(false);
}

/**
 * Contructor of the class
 * @param a 
 * @return 
 */
NMGMain::NMGMain(QApplication &a)
{
	NMGApplicationInformation::createConfigurationDirectory();
	fileManager = NMGConfigurationFileManager::self();	
	loadModules();
	nmConnection = NMGConnection::getConnection();	
	nmConnection->start();
	a.connect( &a, SIGNAL( lastWindowClosed() ), nmConnection, SLOT( end() ) );	
	hostManager = NMGHostInformationManager::self();
	preferencesManager = NMGPreferencesManager::self();
}

/**
 * Destroyer of the class
 * @return 
 */
NMGMain::~NMGMain()
{
//	delete moduleManager;
	NMGApplicationInformation * ai = NMGApplicationInformation::getApplicationInformation();
	delete ai;
	delete hostManager;
	delete preferencesManager;
	delete nmConnection;
	delete fileManager;
}


