/***************************************************************************
 *   Copyright (C) 2005 by Ernest Nieto                                    *
 *   ernest.nieto@gmail.com                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include <messagebar.h>
#include <qstring.h>

#include "daginterpret.h"

NMGDagInterpret::NMGDagInterpret(const QString conv_name) : NMGConverterBase(conv_name)
{
	dagFilter = new QByteArray(3);
	currMagic = new QByteArray();//empty

        (*dagFilter)[0] = 'D';
        (*dagFilter)[1] = 'A';
        (*dagFilter)[2] = 'G';
	
        addDagMagic();
        addDagFilter();
        conversion = 0;
}


NMGDagInterpret::~NMGDagInterpret()
{
        delete dagFilter;
	delete currMagic;
}


void NMGDagInterpret::addDagFilter() {

	QString mFilter("DAG Files (*.erf *.dag)");
	NMGConverterBase::addFilter(mFilter);
}

void NMGDagInterpret::addDagMagic() {
	
	
        NMGConverterBase::addMagic(*currMagic);
}


bool NMGDagInterpret::startConversion(/*ProgressItem *progressItem,*/ const QString & origFile, const QString & fileOutput)
{

    conversion = new NMGDagThread(/*progressItem,*/ origFile, fileOutput);
    if (!conversion)
      return false;
    return true;
}


void NMGDagInterpret::run() {
	conversion->startConversion();
}

void NMGDagInterpret::kill(){
	conversion->stop();
}

bool NMGDagInterpret::isFinished() {
    if (conversion)
        return conversion->isFinished();
    return false;
}

void NMGDagInterpret::getStatus(QString &mess, int *percent, bool *ended) {
    conversion->getStatus(mess, percent, ended);
}
