/***************************************************************************
 *   Copyright (C) 2005 by Ernest Nieto                                    *
 *   ernest.nieto@gmail.com                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef DAGINTERPRET_H
#define DAGINTERPRET_H

#define MAX_MAGIC 4

#include <nmgconverterbase.h>

#include "dagthread.h"

/**
	@author Jos Nez <jnunyez@ac.upc.edu>
*/
class NMGDagInterpret : public NMGConverterBase
{
     NMGDagThread *conversion;
     QByteArray *dagFilter;
     QByteArray *currMagic;

private:
    

public:
    NMGDagInterpret(const QString conv_name);
   ~NMGDagInterpret();
    bool startConversion(/*ProgressItem *progressItem,*/ const QString & origFile, const QString & fileOutput);
    void addDagFilter();
    void addDagMagic();
    virtual void run();
    virtual void kill();
    bool isFinished();
    void getStatus(QString &mess, int *percent, bool *ended);
};

#endif
