/***************************************************************************
 *   Copyright (C) 2005 by Ernest Nieto                                    *
 *   ernest.nieto@gmail.com                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "nmgcflowinfo.h"

NMGCFlowInfo::NMGCFlowInfo()
{
	flowSet = false;
}

NMGCFlowInfo::NMGCFlowInfo(ps_flowInformation tmpInfo) {
	flowSet = false;
	setAll(tmpInfo);
}


NMGCFlowInfo::~NMGCFlowInfo()
{
}

/*!
    \fn NMGCFlowInfo::setFlowID(QString mflowID)
 */
bool NMGCFlowInfo::setFlowID(QString mflowID)
{
    flowInfo.flowID = mflowID;
    return true;
}


/*!
    \fn NMGCFlowInfo::setFlowName(QString mFlowName)
 */
bool NMGCFlowInfo::setFlowName(QString mFlowName)
{
    flowInfo.flowName = mFlowName;
    return true;
}


/*!
    \fn NMGCFlowInfo::setPattern(QString mPattern)
 */
bool NMGCFlowInfo::setPattern(QString mPattern)
{
    flowInfo.pattern = mPattern;
    return true;
}


/*!
    \fn NMGCFlowInfo::setRate(int mRate)
 */
bool NMGCFlowInfo::setRate(int mRate)
{
    flowInfo.rate = mRate;
    return true;
}


/*!
    \fn NMGCFlowInfo::setRelativeStart(int mRelativeStart)
 */
bool NMGCFlowInfo::setRelativeStart(int mRelativeStart)
{
     flowInfo.relativeStart = mRelativeStart;
     return true;
}


/*!
    \fn NMGCFlowInfo::setRelativeStop(int mRelativeStop)
 */
bool NMGCFlowInfo::setRelativeStop(int mRelativeStop)
{
    flowInfo.relativeStop = mRelativeStop;
    return true;
}


/*!
    \fn NMGCFlowInfo::setPacketSize(int mPacketSize)
 */
bool NMGCFlowInfo::setPacketSize(int mPacketSize)
{
    flowInfo.packetSize = mPacketSize;
    return true;
}

/*!
    \fn NMGCFlowInfo::setAll(ps_flowInformation)
 */
bool NMGCFlowInfo::setAll(ps_flowInformation tmpInfo)
{
	if (!tmpInfo)
		return false;
	flowInfo.flowID = tmpInfo->flowID;
	flowInfo.flowName = tmpInfo->flowName;
	flowInfo.relativeStart = tmpInfo->relativeStart;
	flowInfo.relativeStop = tmpInfo->relativeStop;
	flowInfo.pattern = tmpInfo->pattern;
	flowInfo.rate = tmpInfo->rate;
	flowInfo.packetSize = tmpInfo->packetSize;

	flowSet = true;
	return true;
}

/*!
    \fn NMGCFlowInfo::setFlow(bool value)
 */
bool NMGCFlowInfo::setFlow(bool value)
{
	flowSet = value;
	return value;
}

/*!
    \fn NMGCFlowInfo::getFlowID(int *mflowID)
 */
bool NMGCFlowInfo::getFlowID(QString &mflowID)
{
    mflowID = flowInfo.flowID;
    return true;
}


/*!
    \fn NMGCFlowInfo::getFlowName(QString &mFlowName)
 */
bool NMGCFlowInfo::getFlowName(QString &mFlowName)
{
    mFlowName = flowInfo.flowName;
    return true;
}


/*!
    \fn NMGCFlowInfo::getPattern(QString &mPattern)
 */
bool NMGCFlowInfo::getPattern(QString &mPattern)
{
    mPattern = flowInfo.pattern;
    return true;
}


/*!
    \fn NMGCFlowInfo::getRate(int *mRate)
 */
bool NMGCFlowInfo::getRate(int *mRate)
{
    if (!mRate)
	return false;
    else
	*mRate = flowInfo.rate;
    return true;
}


/*!
    \fn NMGCFlowInfo::getRelativeStart(int *mRelativeStart)
 */
bool NMGCFlowInfo::getRelativeStart(int *mRelativeStart)
{
    if (!mRelativeStart)
	return false;
    else
	*mRelativeStart = flowInfo.relativeStart;
    return true;
}


/*!
    \fn NMGCFlowInfo::getRelativeStop(int *mRelativeStop)
 */
bool NMGCFlowInfo::getRelativeStop(int *mRelativeStop)
{
    if (!mRelativeStop)
	return false;
    else
	*mRelativeStop = flowInfo.relativeStop;
    return true;
}


/*!
    \fn NMGCFlowInfo::getPacketSize(int mPacketSize)
 */
bool NMGCFlowInfo::getPacketSize(int *mPacketSize)
{
    if (!mPacketSize)
	return false;
    else
	*mPacketSize = flowInfo.packetSize;
    return true;
}


/*!
    \fn NMGCFlowInfo::getAll(ps_flowInformation)
 */
bool NMGCFlowInfo::getAll(ps_flowInformation tmpInfo)
{
	if (!tmpInfo || !flowSet)
		return false;
	tmpInfo->flowID = flowInfo.flowID;
	tmpInfo->flowName = flowInfo.flowName;
	tmpInfo->relativeStart = flowInfo.relativeStart;
	tmpInfo->relativeStop = flowInfo.relativeStop;
	tmpInfo->pattern = flowInfo.pattern;
	tmpInfo->rate = flowInfo.rate;
	tmpInfo->packetSize = flowInfo.packetSize;
	return true;
}

/*!
    \fn NMGCFlowInfo::getFlow()
 */
bool NMGCFlowInfo::getFlow()
{
	return flowSet;
}
