/***************************************************************************
 *   Copyright (C) 2005 by Ernest Nieto                                    *
 *   ernest.nieto@gmail.com                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include <qstring.h>

#ifndef NMGCFLOWINFO_H
#define NMGCFLOWINFO_H

typedef struct s_NMGCflowInformation {
    QString flowID;
    QString flowName;
    int relativeStart;
    int relativeStop;
    QString pattern;
    int rate;
    int packetSize;
    long receivedPackets;
    long packetLosses;
} s_flowInformation, *ps_flowInformation;

/**
List of flows

@author Rene Serral-Gracia
*/
class NMGCFlowInfo
{
    bool flowSet;
    s_flowInformation flowInfo;
public:
    NMGCFlowInfo(ps_flowInformation);
    NMGCFlowInfo();

    ~NMGCFlowInfo();

    bool setFlowID(QString mflowID);
    bool setFlowName(QString mFlowName);
    bool setPattern(QString mPattern);
    bool setRate(int mRate);
    bool setRelativeStart(int mRelativeStart);
    bool setRelativeStop(int mRelativeStop);
    bool setPacketSize(int mPacketSize);
    bool setAll(ps_flowInformation);
    bool setFlow(bool value);

    bool getFlowID(QString &mflowID);
    bool getFlowName(QString &mFlowName);
    bool getPattern(QString &mPattern);
    bool getRate(int *mRate);
    bool getRelativeStart(int *mRelativeStart);
    bool getRelativeStop(int *mRelativeStop);
    bool getPacketSize(int *mPacketSize);
    bool getAll(ps_flowInformation);
    bool getFlow();

};

#endif
