/*
 *   $Id: nmmgeninterpret.h,v 1.5 2006-07-26 17:18:04 rserral Exp $
 *
 *   Copyright (c) 2006 Ren Serral
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the
 *   Free Software Foundation, Inc.,
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifndef NMMGENINTERPRET_H
#define NMMGENINTERPRET_H

#define TAG_SOURCE	"source"
#define TAG_DESTINATION	"destination"
#define TAG_SEQ		"seq"
#define TAG_FLOW	"flow"
#define TAG_FLOWS	"flows"
#define TAG_TX_TIME	"tx_time"
#define TAG_RX_TIME	"rx_time"
#define TAG_SIZE	"size"
#define TAG_ADDRESS	"address"
#define TAG_PORT	"port"
#define TAG_RESULT	"result"

#define TAG_		""
#define ATTR_ID		"id"

#include <xmlwriter.h>
#include <nmgconverterbase.h>
#include <progressmanager.h>
#include <nmgmgenthread.h>

#include "nmgcflowinfo.h"

#include <list>

#ifndef MAX_MAGIC
#define MAX_MAGIC 4
#endif

/**
* Interpret for the XML documents for the class NMMGen
@author Rene Serral-Gracia
*/
class NMMGenInterpret : public NMGConverterBase
{
    NMGMGenThread *conversion;
    void chooseFilter(QString &origFile, QString &mclFile);
    QByteArray *dlyFilter;
    QByteArray *mclFilter;
public:
    NMMGenInterpret(const QString conv_name);
    ~NMMGenInterpret();

    bool startConversion(const QString & origFile, const QString & testOutput);
    void addFilter();
    void addMagic();
    virtual void run();
    virtual void kill();
    bool isFinished();
    void getStatus(QString &mess, int *percent, bool *ended);
};

#endif
