/***************************************************************************
 *   Copyright (C) 2005 by Ernest Nieto                                    *
 *   ernest.nieto@gmail.com                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include <qstring.h>
#include "nmgcapturedflow.h"



NMGCapturedFlow::NMGCapturedFlow(QString rx_time)
{	
	flowInfo.qty = 1;
	NMGpaqInfo *aPaquet = new NMGpaqInfo(rx_time);
	//aPaquet->setSeqId(  QString("0") );//tmp
	flowInfo.paqsPerFlow.push_back(aPaquet);
}


NMGCapturedFlow::~NMGCapturedFlow()
{
}

bool NMGCapturedFlow::setFlowID(QString mflowID)
{
	flowInfo.flowID = mflowID;
	return true;
}

bool NMGCapturedFlow::setSourceAddress(QString saddr)
{
	flowInfo.saddr = saddr;
	return true;
}

bool NMGCapturedFlow::setDestinationAddress(QString daddr)
{
	flowInfo.daddr = daddr;
	return true;
}

bool NMGCapturedFlow::setSourcePort(QString sport)
{
	flowInfo.sport = sport;
	return true;
}

bool NMGCapturedFlow::setDestinationPort(QString dport)
{
	flowInfo.dport = dport;
	return true;

}

bool NMGCapturedFlow::setSeqID( QString seqid )
{
	NMGpaqInfo *tmpPaq = flowInfo.paqsPerFlow.back();
	tmpPaq->setSeqId(seqid);
	return true;
}

bool NMGCapturedFlow::setSize( QString size )
{
	NMGpaqInfo *aPaquet = flowInfo.paqsPerFlow.front();
	aPaquet->setSize( size );
	return true;
}

bool NMGCapturedFlow::addPaquetInfo( NMGCapturedFlow *capturedPacket )
{
	
	
	flowInfo.paqsPerFlow.push_back( capturedPacket->flowInfo.paqsPerFlow.back() );
	return true;
}

QString NMGCapturedFlow::getFlowID()
{
	return flowInfo.flowID;
}

QString NMGCapturedFlow::getSourceAddress()
{
	return flowInfo.saddr;
}

QString NMGCapturedFlow::getDestinationAddress()
{
	return flowInfo.daddr;
}

QString NMGCapturedFlow::getSourcePort()
{
	return flowInfo.sport;
}

QString NMGCapturedFlow::getDestinationPort()
{
	return flowInfo.dport;

}

list<NMGpaqInfo *> NMGCapturedFlow::getListPaquet()
{
	return flowInfo.paqsPerFlow;
}

int NMGCapturedFlow::getQty()
{
	return flowInfo.qty;
}
void NMGCapturedFlow::incQty()
{
	flowInfo.qty++;
}
bool NMGCapturedFlow::eqFlow( NMGCapturedFlow *currFlow )
{
	if ( ( currFlow->getSourceAddress() == flowInfo.saddr ) && ( currFlow->getDestinationAddress() == flowInfo.daddr ) && ( currFlow->getSourcePort() == flowInfo.sport ) && ( currFlow->getDestinationPort() == flowInfo.dport ) )
		return true;
	else 
		return false;
}