/***************************************************************************
 *   Copyright (C) 2005 by Ernest Nieto                                    *
 *   ernest.nieto@gmail.com                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#ifndef NMGCAPTUREDFLOW_H
#define NMGCAPTUREDFLOW_H

#include <qstring.h>
#include <nmthread.h>
#include "nmgpaquetinfo.h"


struct capturedFlowInformation {
    QString flowID;
    QString saddr;
    QString daddr;
    QString sport;
    QString dport;
    int qty;
    list<NMGpaqInfo *> paqsPerFlow;


};



/**
List of flows

@author Jos Nez Martnez
*/

class NMGCapturedFlow
{
    capturedFlowInformation flowInfo;
public:

    NMGCapturedFlow(QString rx_time);
    ~NMGCapturedFlow();
    bool setFlowID(QString mflowID);
    bool setSourceAddress(QString saddr);
    bool setDestinationAddress(QString daddr);
    bool setSourcePort(QString sport);
    bool setDestinationPort(QString dport);
    bool setSeqID( QString seqid );
    bool setSize( QString size );
    bool addPaquetInfo( NMGCapturedFlow *capturedPacket );
    bool eqFlow(NMGCapturedFlow *currFlow);
    QString getFlowID();
    QString getSourceAddress();
    QString getDestinationAddress();
    QString getSourcePort();
    QString getDestinationPort();
    list<NMGpaqInfo *> getListPaquet();
    QString pushBackPacket();
    int getQty();
    void incQty();
};

#endif

