/***************************************************************************
 *   Copyright (C) 2005 by Ren Serral-Graci                              *
 *   rserral@ac.upc.edu                                                    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "nmgconverter.h"

#include <iostream>
using namespace std;

/**
 * Constructor of the class
 * @return 
 */
NMGConverter::NMGConverter()
{
	moduleName = MOD_NAME;
	moduleCapabilities = MOD_CAPABILITIES;
	moduleVersion = MOD_VERSION;
	moduleCoreMatching = CORE_MATCHING;
	moduleGUIName = GUI_NAME;
	widget = 0;
	
}

void NMGConverter::createWidget()
{
	if (!widget)
		widget = new NMGConverterMgr(&getTabWidgetManager(), &getPreferencesManager());
}

/**
 * Destructor of the class
 * @return 
 */
NMGConverter::~NMGConverter()
{
}

/**
 * Returns the widget of the plugin
 * @return 
 */
QWidget * NMGConverter::getWidget()
{
	if (!widget)
		createWidget();
	return widget;
}

/**
 * Executed when the host widget is hidden
 * @param  station Station created
 */
void NMGConverter::notifyNewStation(NMGStation * station)
{
	cout << "NMExemple ..." << endl;
	if(!station) return;
}

void NMGConverter::dataReceived(QString data)
{
	cout << "**************************************"<<endl;
	cout << "NMExemple receive start reply: " <<endl << data << endl;
	cout << "**************************************"<<endl;
}

/**
 * Returns the pop up menu of the module
 * @return 
 */
QPopupMenu * NMGConverter::getPopupMenu()
{
	if (!widget)
		createWidget();
	return widget->getPopupMenu();
}

/**
 * Returns the toolbar associated to the module
 * @return 
 */
QToolBar * NMGConverter::getToolBar()
{
	createWidget();
	return widget->getToolBar();
}

/**
 * Initializes the plugin
 */
void NMGConverter::initModuleGUI()
{
}

/**
 * Frees the plugin resources
 */
void NMGConverter::removeModuleGUI()
{
}
