/***************************************************************************
 *   Copyright (C) 2005 by Ren Serral-Graci                              *
 *   rserral@ac.upc.edu                                                    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef NMGCONVERTER_H
#define NMGCONVERTER_H


#include <nmgmodule.h>

#include "nmgconvertermgr.h"

#define MOD_CLASS	NMGConverter
#define MOD_NAME	"NMGConverter"
#define MOD_CAPABILITIES	"converter"
#define MOD_VERSION	"0.1"
#define CORE_MATCHING	""
#define GUI_NAME	"File format Converter"

/**
@author Rene Serral-Gracia
*/
class NMGConverter : public NMGModule
{
public:
    NMGConverter();

    ~NMGConverter();

    void initModuleGUI();
    void removeModuleGUI();

    void notifyNewStation(NMGStation *);
    
    void dataReceived(QString data);
    
    void createWidget();
    QWidget * getWidget();
    
    QPopupMenu * getPopupMenu();
    QToolBar * getToolBar();
private:
    NMGConverterMgr *widget;
};

#define FIELDS2 ((char ***) {{"App1","App 1 Path"},{"App2","App 2 Path"},0})
#define FIELDS 0


NMMODULE_CLASS(MOD_CLASS)
NMMODULE_NAME((char *) MOD_NAME)
NMMODULE_CAPABILITIES((char *) MOD_CAPABILITIES)
NMMODULE_VERSION((char *) MOD_VERSION)
NMMODULE_CORENAME((char *)CORE_MATCHING)
NMMODULE_GUINAME((char *)GUI_NAME)
NMMODULE_TOOLTIP((char *) "Module for converting various file formats.\nFor now it supports MGEN only.")

#endif
