/***************************************************************************
 *   Copyright (C) 2006 by Ren Serral-GRaci                              *
 *   rserral@ac.upc.edu                                                    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include <qcstring.h>
#include <qstringlist.h>

#include <progressmanager.h>
#include <nmthread.h>

#include <iostream>
#include <fstream>
#include <list>
using namespace std;

#ifndef NMGCONVERTERBASE_H
#define NMGCONVERTERBASE_H

/**
Base class for the Conversion framework

@author Rene Serral-Gracia
*/
class NMGConverterBase : public NMThread {
    list<QByteArray> magic;
    QStringList filter;
    QString iFile, oFile;
    QString name;

public:
    NMGConverterBase(const QString conv_name);

    virtual ~NMGConverterBase();

    QString getName();
    virtual bool startConversion(const QString & origFile, const QString & testOutput);
    virtual bool startDualConversion(const QString & orig1File, const QString & orig2File, const QString & testOutput);
    virtual void addFilter(QString & theFilter);
    virtual void addMagic(QByteArray & theMagic);
    virtual QStringList &filters();
    virtual list<QByteArray> &magics();
    virtual void kill();
    virtual void run();
    virtual bool isFinished();
    virtual void getStatus(QString &, int *, bool *);

protected:
    ProgressItem *progressBar;
};

#endif
