/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/

void NMGConverterWidget::initDialogs(QString &inputDir, QString &outputDir)
{
    QString qsDefaultFilter = "*";  // "MGen Files (*.mcl *.dly)";
    fdInput = new QFileDialog(inputDir, qsDefaultFilter, this, 0, true);
    fdOutput = new QFileDialog(outputDir, "XML File Format (*.xff)", this, 0, true);
    fdOutput ->setMode( QFileDialog::AnyFile );
}

void NMGConverterWidget::pb_openInput_clicked()
{
    if ( fdInput->exec() == QDialog::Accepted ) {
	iFile1Name = fdInput->selectedFile();
	le_ifile->setText(iFile2Name);
    }
}

void NMGConverterWidget::pb_openOutput_clicked()
{
    if ( fdOutput->exec() == QDialog::Accepted ) {
	oFileName = fdOutput->selectedFile();
	le_ofile->setText(oFileName);
    }
}

void NMGConverterWidget::le_ifile_lost_focus()
{
    updateFromLE(le_ifile->text(), iFile1Name);
}

void NMGConverterWidget::le_ofile_lost_focus()
{
    updateFromLE(le_ofile->text(), oFileName);
}

void NMGConverterWidget::updateFromLE( const QString newValue, QString & fileName )
{
    fileName = newValue;
}

QString NMGConverterWidget::getiFile1Name()
{
    return iFile1Name;
}

QString NMGConverterWidget::getiFile2Name()
{
    return iFile2Name;
}

QString NMGConverterWidget::getoFileName()
{
    return oFileName;
}

void NMGConverterWidget::NMGConverterWidget_destroyed( QObject * )
{
    delete fdInput;
    delete fdOutput;
}

void NMGConverterWidget::addInputFilter( QString mFilter )
{
    fdInput->addFilter(mFilter);
}


void NMGConverterWidget::le_ifile_textChanged( const QString &iFile)
{
    updateFromLE(iFile, iFile1Name);
}


void NMGConverterWidget::le_ofile_textChanged( const QString &oFile )
{
    updateFromLE(oFile, oFileName);
}


void NMGConverterWidget::le_ifile_2_lostFocus()
{
    updateFromLE(le_ifile->text(), iFile2Name);
}


void NMGConverterWidget::pb_openInput_2_clicked()
{
    if ( fdInput->exec() == QDialog::Accepted ) {
	iFile2Name = fdInput->selectedFile();
	le_ifile->setText(iFile2Name);
    }
}


void NMGConverterWidget::le_ifile_2_textChanged( const QString &iFile )
{
    updateFromLE(iFile, iFile2Name);
}
