/***************************************************************************
 *   Copyright (C) 2005 by Ernest Nieto                                    *
 *   ernest.nieto@gmail.com                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include <messagebar.h>
#include <qstring.h>


#include "pcapinterpret.h"

NMGPcapInterpret::NMGPcapInterpret(const QString conv_name) : NMGConverterBase(conv_name)
{
	pcapFilter = new QByteArray(4);
	(*pcapFilter)[3] = 0xa1;
	(*pcapFilter)[2] = 0xb2;
	(*pcapFilter)[1] = 0xc3;
	(*pcapFilter)[0] = 0xd4;
        addPcapFilter();	
        addPcapMagic();
        conversion = 0;
}
void NMGPcapInterpret::addPcapFilter() {

	QString mFilter("PCAP Files (*.pcap files)");
	NMGConverterBase::addFilter(mFilter);
}

void NMGPcapInterpret::addPcapMagic() 
{
	NMGConverterBase::addMagic(*pcapFilter);
}

bool NMGPcapInterpret::startConversion(/*ProgressItem *progressItem,*/ const QString & origFile, const QString & fileOutput)
{

	conversion = new NMGPcapThread(/*progressItem,*/origFile,fileOutput);
	if (!conversion)
		return false;
	return true;
}

void NMGPcapInterpret::run()
{
	conversion->startConversion();
}

void NMGPcapInterpret::kill()
{
	conversion->stop();
}

bool NMGPcapInterpret::isFinished()
{
    if (conversion)
        return conversion->isFinished();
    return false;
}

void NMGPcapInterpret::getStatus(QString &mess, int *percent, bool *ended)
{
    conversion->getStatus(mess, percent, ended);
}

NMGPcapInterpret::~NMGPcapInterpret()
{
        delete pcapFilter;
}
