/***************************************************************************
 *   Copyright (C) 2005 by David Lacort                                    *
 *   david.lacort@gmail.com                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef NMGFLOWLISTITEM_H
#define NMGFLOWLISTITEM_H

#include <qlistview.h>

/**
	@author David Lacort <david.lacort@gmail.com>
*/

class NMGFlowListItem : public QListViewItem
{
public:
	NMGFlowListItem ( QListView * parent, QString label1, QString label2 = QString::null, QString label3 = QString::null, QString label4 = QString::null, QString label5 = QString::null, QString label6 = QString::null, QString label7 = QString::null, QString label8 = QString::null );

    virtual void paintCell( QPainter *p, const QColorGroup &cg, int column, int width, int alignment );

	void setColors(QColor col_textColor, QColor col_baseColor);
	void getColors(QColor &col_textColor, QColor &col_baseColor);
	bool isHidden();
	void setHidden(bool b_hidden);
	bool isAveraged();
	void setAveraged(bool b_averaged);
	bool isAccumulated();
	void setAccumulated(bool b_accumulated);

	bool polygonsShowed();
	void setPolygonsShowed(bool b_showed);
	bool linesShowed();
	void setLinesShowed(bool b_showed);
	bool areaShowed();
	void setAreaShowed(bool b_showed);

	bool polygonSquare();
	bool polygonTriangle();
	bool polygonRhomb();
	bool polygonInvertedTriangle();
	void setPolygonSquare();
	void setPolygonTriangle();
	void setPolygonRhomb();
	void setPolygonInvertedTriangle();

	int getDotSize();
	void setDotSize(int i_dotSize);

	
private:
	QColor m_col_textColor;
	QColor m_col_baseColor;
	bool m_b_isHidden;
	bool m_b_isAveraged;
	bool m_b_isAccumulated;
	bool m_b_polygonsShowed;
	bool m_b_linesShowed;
	bool m_b_areaShowed;
	bool m_b_polygonSquare;
	bool m_b_polygonTriangle;
	bool m_b_polygonRhomb;
	bool m_b_polygonInvertedTriangle;
	int m_i_dotSize;
};

#endif
