/***************************************************************************
 *   Copyright (C) 2005 by David Lacort                                    *
 *   david.lacort@gmail.com                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef NMGGLOADERTHREAD_H
#define NMGGLOADERTHREAD_H

#include <nmthread.h>
#include <qstring.h>

#include "nmgmgenxmlflowformatparser.h"

/**
	@author David Lacort <david.lacort@gmail.com>
*/
class NMGGLoaderThread : public NMThread
{
public:
    NMGGLoaderThread();

    ~NMGGLoaderThread();

	void loadGraphData(QString str_fileName);
	void acceptInvalidData(bool b_accept);
    void kill();
    void run();

	bool isFinished();
	int getError();
	QString getErrorString();
	QList<NMGMGENReadFlowData>* getReadData();
	int getPercentCompleted();
	QString getLoadStatus();

private:
	QString m_str_fileName;
	bool m_b_acceptInvalidData;
	NMGMGENXMLFlowFormatParser *m_xffp_parser;
};

#endif
