/***************************************************************************
 *   Copyright (C) 2005 by David Lacort                                    *
 *   david.lacort@gmail.com                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "nmggraph.h"

NMGGraph::NMGGraph()
{
	moduleName = MOD_NAME;
	moduleCapabilities = MOD_CAPABILITIES;
	moduleVersion = MOD_VERSION;
	moduleCoreMatching = CORE_MATCHING;
	moduleGUIName = GUI_NAME;
	widget=0;
}

NMGGraph::~NMGGraph()
{
}

void NMGGraph::initModuleGUI()
{

}

void NMGGraph::removeModuleGUI()
{

}


void NMGGraph::createWidget()
{
	if(!widget) 
		widget = new NMGGraphWidget(0,"graphic widget",&getPreferencesManager());
}

/**
 * Returns the widget menu associated to the module
 * @return 
 */
QWidget * NMGGraph::getWidget()
{
	createWidget();
	return widget;
}
 
/**
 * Returns the popup menu associated to the module
 * @return 
 */
QPopupMenu * NMGGraph::getPopupMenu()
{
	createWidget();
	return widget->getPopupMenu();
}   

/**
 * Returns the toolbar associated to the module
 * @return 
 */
QToolBar * NMGGraph::getToolBar()
{
	createWidget();
	return widget->getToolBar();
}

