/***************************************************************************
 *   Copyright (C) 2006 by David Lacort                                    *
 *   david.lacort@gmail.com                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef NMGGRAPH_H
#define NMGGRAPH_H

#include <nmgmodule.h>
#include "nmggraphwidget.h"


#define MOD_CLASS	NMGGraph
#define MOD_NAME	"NMGGraph"
#define MOD_CAPABILITIES	"Analysis"
#define MOD_VERSION	"0.1"
#define CORE_MATCHING	"Graph"
#define GUI_NAME	"Graphic Distribution"

/**
@author David Lacort
*/
class NMGGraph : public NMGModule
{
public:
    NMGGraph();
    ~NMGGraph();

    void initModuleGUI();
    void removeModuleGUI();
    
    QWidget * getWidget();
	QPopupMenu * getPopupMenu();
	QToolBar * getToolBar();

private:
	void createWidget();

    NMGGraphWidget * widget;
};

NMMODULE_CLASS(MOD_CLASS)
NMMODULE_NAME((char *) MOD_NAME)
NMMODULE_CAPABILITIES((char *) MOD_CAPABILITIES)
NMMODULE_VERSION((char *) MOD_VERSION)
NMMODULE_CORENAME((char *)CORE_MATCHING)
NMMODULE_GUINAME((char *)GUI_NAME)
NMMODULE_MODULEICON((char *)"graphicon.png")
NMMODULE_TOOLTIP((char *) "Module for the graphic visualization of results")


#endif
