/***************************************************************************
 *   Copyright (C) 2005 by David Lacort                                    *
 *   david.lacort@gmail.com                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef NMGGRAPHDATALOADER_H
#define NMGGRAPHDATALOADER_H

#include "nmggraphicwidget.h"
#include "nmgflowlistview.h"
#include "nmgreadflowdata.h"

/**
	@author David Lacort <david.lacort@gmail.com>
*/
class NMGGraphDataLoader{
public:
    NMGGraphDataLoader();
    virtual ~NMGGraphDataLoader();

	int getGraphType();
	void setGraphType(int i_type);
	QPtrList<QString> getGraphTypeLabels();
	QString getGraphLabel();
	virtual QPtrList<QString> getGraphTypeOptionsLabels();
	virtual void setGraphTypeOption(int i_option);

	virtual void loadGraphData(QString str_fileName);
	virtual int endLoadGraphData(NMGGraphicWidget *gw_TheGraph, NMGFlowListView *flv_FlowList);

	virtual bool isFinished();
	virtual int getError();
	virtual QString getErrorString();
	virtual void processError(int i_error, QString str_error);
	virtual void resetError();

	virtual void cancelLoad();
	virtual void getLoadStatus(QString str_message, int *i_percent, bool *b_finished);

	virtual bool reloadAllGraphs(NMGGraphicWidget *gw_TheGraph, NMGFlowListView *flv_FlowList);

	virtual void removeSelectedGraph(NMGGraphicWidget *gw_TheGraph, NMGFlowListView *flv_FlowList);

protected:
	int m_i_graphType;
	QPtrList<QString> m_strl_graphTypes;
	QPtrList<QString> m_strl_graphTypeOptions;
	QPtrList<NMGReadFlowData> m_rfdl_readData;

	int m_i_error;
	QString m_str_error;
};

#endif
