/***************************************************************************
 *   Copyright (C) 2005 by David Lacort                                    *
 *   david.lacort@gmail.com                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "nmgmgenmetadata.h"

NMGMGENMetadata::NMGMGENMetadata()
: NMGMGENTestMetadata()
{
	m_fml_flowMetadataList.setAutoDelete(true);
}

NMGMGENMetadata::NMGMGENMetadata(NMGMGENMetadata *metadata)
: NMGMGENTestMetadata(metadata)
{
	m_fml_flowMetadataList.setAutoDelete(true);
}

NMGMGENMetadata::~NMGMGENMetadata()
{
}


void NMGMGENMetadata::addFlowMetadata(NMGMGENFlowMetadata *flowMeta)
{
	m_fml_flowMetadataList.append(flowMeta);
}

NMGMGENFlowMetadata* NMGMGENMetadata::getFlowMetadata(QString str_flowId)
{
	m_fml_flowMetadataList.first();
	while (m_fml_flowMetadataList.current()!=0 && m_fml_flowMetadataList.current()->getId()!=str_flowId)
		m_fml_flowMetadataList.next();
	
	return m_fml_flowMetadataList.current();
}

