/***************************************************************************
 *   Copyright (C) 2005 by David Lacort                                    *
 *   david.lacort@gmail.com                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "nmgxmlflowformatreader.h"

#include <qfile.h>
#include <iostream>

using namespace std;

NMGXMLFlowFormatReader::NMGXMLFlowFormatReader()
{
}


NMGXMLFlowFormatReader::~NMGXMLFlowFormatReader()
{
}

void NMGXMLFlowFormatReader::setFile(QString str_fileName)
{
	m_str_fileName = str_fileName;
}

bool NMGXMLFlowFormatReader::fileExists()
{
	QFile file(m_str_fileName);
	if(!file.exists())
	{
		m_str_error = "Error opening file: the file "+m_str_fileName+" doesn't exist";
		return false;
	}
	return true;
}

bool NMGXMLFlowFormatReader::readData()
{
	QFile file (m_str_fileName);
	if(!file.open(IO_ReadOnly))
	{
		m_str_error = "Error opening file: the file "+m_str_fileName+" doesn't exist or is not readable.";
		return false;
	}
	QString str_errorMessage; 
	int i_errorLine;
	int i_errorColumn;
	if ( !document.setContent( &file, &str_errorMessage, &i_errorLine, &i_errorColumn) )
	{
		m_str_error = "Error: the XML file "+m_str_fileName+" is not well formed (" + str_errorMessage + 
			" - line " + QString("%1").arg(i_errorLine) + ", column "+QString("%1").arg(i_errorColumn)+").";
		file.close();
		return false;
	}
	file.close();

	// Parse the metadata
	getMetadataFromXML();

	return true;
}

void NMGXMLFlowFormatReader::getMetadataFromXML()
{
}


QString NMGXMLFlowFormatReader::getError()
{
	return m_str_error;
}

QString NMGXMLFlowFormatReader::getTestName()
{
	return m_str_testName;
}

QString NMGXMLFlowFormatReader::getTestId()
{
	return m_str_testId;
}

QString NMGXMLFlowFormatReader::getSrcAddress()
{
	return m_str_srcAddress;
}

QString NMGXMLFlowFormatReader::getDstAddress()
{
	return m_str_dstAddress;
}

