/***************************************************************************
 *   Copyright (C) 2005 by David Lacort                                    *
 *   david.lacort@gmail.com                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef NMGXMLFLOWFORMATREADER_H
#define NMGXMLFLOWFORMATREADER_H

#include <qdom.h>
#include <qstring.h>

/**
	@author David Lacort <david.lacort@gmail.com>
*/
class NMGXMLFlowFormatReader{
public:
    NMGXMLFlowFormatReader();
    virtual ~NMGXMLFlowFormatReader();

	void setFile(QString str_fileName);
	bool fileExists();
	bool readData();
	QString getError();
	
	QString getTestName();
	QString getTestId();
	QString getSrcAddress();
	QString getDstAddress();

protected:
	QDomDocument document;
	QString m_str_error;
	QString m_str_fileName;

	QString m_str_testName;
	QString m_str_testId;
	QString m_str_mgenVersion;
	QString m_str_srcAddress;
	QString m_str_dstAddress;
	
	virtual void getMetadataFromXML();

private:
	
};

#endif
