/***************************************************************************
 *   Copyright (C) 2005 by Ernest Nieto                                    *
 *   ernest.nieto@gmail.com                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "nmgxmlflowsortedlist.h"

#include <iostream>
using namespace std;

/**
 * Contructor of the class
 * @return 
 */
NMGXMLFlowSortedList::NMGXMLFlowSortedList()
 : QPtrList<QDomElement>()
{
	setAutoDelete(true);
}

/**
 * Destroyer of the class
 * @return 
 */
NMGXMLFlowSortedList::~NMGXMLFlowSortedList()
{
}



// int QPtrList::compareItems ( QPtrCollection::Item item1, QPtrCollection::Item item2 ) [virtual protected]
// 
// This virtual function compares two list items.
// 
// Returns:
// 
//     * zero if item1 == item2
//     * nonzero if item1 != item2 
// 
// This function returns int rather than bool so that reimplementations can return three values and use it to sort by:
// 
//     * 0 if item1 == item2
//     * > 0 (positive integer) if item1 > item2
//     * < 0 (negative integer) if item1 < item2 
// 
// inSort() requires that compareItems() is implemented as described here.

/**
 * Compares two items (looking the time attribute)
 * @param item1 
 * @param item2 
 * @return 
 */
int NMGXMLFlowSortedList::compareItems ( QPtrCollection::Item item1, QPtrCollection::Item item2 )
{
	QDomElement * elem1 = (QDomElement *) item1;
	QDomElement * elem2 = (QDomElement *) item2;
	int time1 = elem1->attribute(ATTR_TIME).toInt(), time2 = elem2->attribute(ATTR_TIME).toInt();
	if(time1<time2) return -1;
	else if(time1>time2) return 1;
	else
	{	//si tiene el attributo flow_id, se ordena por ahí también, sino no
		if(not elem1->hasAttribute(ATTR_FLOW_ID)) return 0;
		else
		{
			int flowId1 = elem1->attribute(ATTR_FLOW_ID).toInt(), flowId2 = elem2->attribute(ATTR_FLOW_ID).toInt();
			if(flowId1<flowId2) return -1;
			else if(flowId1>flowId2) return 1;
			else
			{ //on tiene que ir antes que mod
				if(elem1->tagName()==TAG_ON) return -1;
				else if(elem2->tagName()==TAG_ON) return 1;
				return 0;
			}
		}
	}
}

