/***************************************************************************
 *   Copyright (C) 2007 by Roberto Barreda                                 *
 *   rbarreda@ac.upc.edu                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "nmgstatisticdata.h"

NMGStatisticData::NMGStatisticData()
{
	m_fml_flowDataList.setAutoDelete(true);
}


NMGStatisticData::~NMGStatisticData()
{
}


void NMGStatisticData::addFlowData(NMGStatisticFlowData *flowData)
{
	m_fml_flowDataList.append(flowData);
}


NMGStatisticFlowData* NMGStatisticData::getFlowData(QString str_flowId)
{
	m_fml_flowDataList.first();
	while (m_fml_flowDataList.current()!=0 && m_fml_flowDataList.current()->getId()!=str_flowId)
		m_fml_flowDataList.next();
	
	return m_fml_flowDataList.current();
}

NMGStatisticFlowData* NMGStatisticData::getFlowDataAt(int index)
{
	return m_fml_flowDataList.at(index);
}

uint NMGStatisticData::getFlowCount() {
	return m_fml_flowDataList.count();
}
