/***************************************************************************
 *   Copyright (C) 2007 by Roberto Barreda                                 *
 *   rbarreda@ac.upc.edu                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "nmgstatisticflowdata.h"

#include <iostream>
using namespace std;

NMGStatisticFlowData::NMGStatisticFlowData()
{ }

NMGStatisticFlowData::NMGStatisticFlowData ( NMGStatisticFlowData *fmd_flowData )
{
	if ( fmd_flowData )
	{
		m_str_id = fmd_flowData->getId();
		
		sent = fmd_flowData->sentPackets();
		dupl = fmd_flowData->duplicatePackets();
		lost = fmd_flowData->lostPackets();
	
		min_delay = fmd_flowData->minDelay();
		max_delay = fmd_flowData->maxDelay();
		avg_delay = fmd_flowData->averageDelay();
		stDev_delay = fmd_flowData->stDevDelay();
		delay_jitter = fmd_flowData->jitterDelay();
		delay_percentile50 = fmd_flowData->delay50Percentile();
		delay_percentile95 = fmd_flowData->delay95Percentile();
		delay_percentile99 = fmd_flowData->delay99Percentile();
		delay_percentile999 = fmd_flowData->delay999Percentile();
		
		min_ipdv = fmd_flowData->minIPDV();
		max_ipdv = fmd_flowData->maxIPDV();
		avg_ipdv = fmd_flowData->averageIPDV();
		stDev_ipdv = fmd_flowData->stDevIPDV();
		ipdv_jitter = fmd_flowData->jitterIPDV();
		ipdv_percentile50 = fmd_flowData->ipdv50Percentile();
		ipdv_percentile95 = fmd_flowData->ipdv95Percentile();
		ipdv_percentile99 = fmd_flowData->ipdv99Percentile();
		ipdv_percentile999 = fmd_flowData->ipdv999Percentile();
	}
}

NMGStatisticFlowData::~NMGStatisticFlowData()
{}

/** Seters **/

void NMGStatisticFlowData::setId ( QString str_param )  { m_str_id = str_param; }

void NMGStatisticFlowData::setSentPackets ( long long in ) { sent = in; }
void NMGStatisticFlowData::setDuplicatePackets ( long long in ) { dupl = in; }
void NMGStatisticFlowData::setLostPackets ( long long in ) { lost = in; }

void NMGStatisticFlowData::setAverageDelay ( double in ) { avg_delay = in; }
void NMGStatisticFlowData::setMinDelay ( double in ) { min_delay = in; }
void NMGStatisticFlowData::setMaxDelay ( double in ) { max_delay = in; }
void NMGStatisticFlowData::setStDevDelay ( double in ) { stDev_delay = in; }
void NMGStatisticFlowData::setJitterDelay ( double in ) { delay_jitter = in; }
void NMGStatisticFlowData::setDelay99Percentile ( double in ) { delay_percentile99 = in; }
void NMGStatisticFlowData::setDelay95Percentile ( double in ) { delay_percentile95 = in; }
void NMGStatisticFlowData::setDelay999Percentile ( double in ) { delay_percentile999 = in; }
void NMGStatisticFlowData::setDelay50Percentile ( double in ) { delay_percentile50 = in; }

void NMGStatisticFlowData::setAverageIPDV ( double in ) { avg_ipdv = in; }
void NMGStatisticFlowData::setMinIPDV ( double in ) { min_ipdv= in; }
void NMGStatisticFlowData::setMaxIPDV ( double in ) { max_ipdv = in; }
void NMGStatisticFlowData::setStDevIPDV ( double in ) { stDev_ipdv = in; }
void NMGStatisticFlowData::setJitterIPDV ( double in ) { ipdv_jitter = in; }
void NMGStatisticFlowData::setIpdv99Percentile ( double in ) { ipdv_percentile99 = in; }
void NMGStatisticFlowData::setIpdv95Percentile ( double in ) { ipdv_percentile95 = in; }
void NMGStatisticFlowData::setIpdv999Percentile ( double in ) { ipdv_percentile999 = in; }
void NMGStatisticFlowData::setIpdv50Percentile ( double in ) { ipdv_percentile50 = in; }

/** Geters **/

QString NMGStatisticFlowData::getId() { return m_str_id;}
long long NMGStatisticFlowData::sentPackets() {return sent;}
long long NMGStatisticFlowData::duplicatePackets() {return dupl;}
long long NMGStatisticFlowData::lostPackets() {return lost;}

double NMGStatisticFlowData::averageDelay() {return avg_delay;}
double NMGStatisticFlowData::minDelay() {return min_delay;}
double NMGStatisticFlowData::maxDelay() {return max_delay;}
double NMGStatisticFlowData::stDevDelay() {return stDev_delay;}
double NMGStatisticFlowData::jitterDelay() {return delay_jitter;}
double NMGStatisticFlowData::delay99Percentile() {return delay_percentile99;}
double NMGStatisticFlowData::delay95Percentile() {return delay_percentile95;}
double NMGStatisticFlowData::delay999Percentile() {return delay_percentile999;}
double NMGStatisticFlowData::delay50Percentile() {return delay_percentile50;}

double NMGStatisticFlowData::averageIPDV() {return avg_ipdv;}
double NMGStatisticFlowData::minIPDV() {return min_ipdv;}
double NMGStatisticFlowData::maxIPDV() {return max_ipdv;}
double NMGStatisticFlowData::stDevIPDV() {return stDev_ipdv;}
double NMGStatisticFlowData::jitterIPDV() {return ipdv_jitter;}
double NMGStatisticFlowData::ipdv99Percentile() {return ipdv_percentile99;}
double NMGStatisticFlowData::ipdv95Percentile() {return ipdv_percentile95;}
double NMGStatisticFlowData::ipdv999Percentile() {return ipdv_percentile999;}
double NMGStatisticFlowData::ipdv50Percentile() {return ipdv_percentile50;}

void NMGStatisticFlowData::checkFlowDataValues() {
	cout << "***********************************************" << endl;
	cout << "RESUM OF NMGStatisticFlowData" << endl;
 	cout << m_str_id << endl;
	cout << sent << endl;
	cout << dupl << endl;
	cout << lost << endl;
	cout << "DELAY" << endl;
	cout << min_delay << endl;
	cout << max_delay << endl;
	cout << avg_delay << endl;
	cout << stDev_delay << endl;
	cout << delay_jitter << endl;
	cout << delay_percentile50 << endl;
	cout << delay_percentile95 << endl;
	cout <<  delay_percentile99<< endl;
	cout << delay_percentile999 << endl;
	cout << "IPDV" << endl;
	cout << min_ipdv << endl;
	cout << max_ipdv << endl;
	cout << avg_ipdv << endl;
	cout << stDev_ipdv << endl;
	cout << ipdv_jitter << endl;
	cout << ipdv_percentile50 << endl;
	cout << ipdv_percentile95 << endl;
	cout << ipdv_percentile99 << endl;
	cout << ipdv_percentile999 << endl;
	cout << "***********************************************" << endl;
}
