/***************************************************************************
 *   Copyright (C) 2007 by Roberto Barreda                                 *
 *   rbarreda@ac.upc.edu                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef NMGNETPERFXMLINTERPRET_H
#define NMGNETPERFXMLINTERPRET_H


#include <qdom.h>
#include <qstring.h>

class NMGNetperfWidget;


class NMGNetperfXMLInterpret
{
public:
    NMGNetperfXMLInterpret(NMGNetperfWidget * w);

    ~NMGNetperfXMLInterpret();

    QString generateXMLTestDocument(bool putUserAndPass);
    
    void updateWidgetFromXMLDocument(QDomElement & root);
    
    QString getResultFilePathFromResult(const QString & xmlMessage);
    
    int parseStatusMessage(const QString & xmlMessage);
    
private:
    void createXMLConfNetperf(QDomDocument & doc, QDomElement & root); 
    void createXMLConfNetserver(QDomDocument & doc, QDomElement & root); 
    void updateWidgetFromXMLNodeSource(QDomElement & elem);
    void updateWidgetFromXMLNodeDestination(QDomElement & elem);
    void updateWidgetFromXMLNodeConfNetperf(QDomElement & elem);
    void updateWidgetFromXMLNodeConfNetserver(QDomElement & elem);
    
private:
    NMGNetperfWidget * widget;

};

#endif
