/***************************************************************************
 *   Copyright (C) 2005 by Pau Capella                                     *
 *   pcapella@ac.upc.edu                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef NMGORENETA_H
#define NMGORENETA_H

#include "../nmgmodule.h"
#include <nmgorenetawidget.h>

#define MOD_CLASS	NMGOreneta
#define MOD_NAME	"nmgoreneta"
#define MOD_CAPABILITIES	"test"
#define MOD_VERSION	"0.1"
#define CORE_MATCHING	"nmoreneta"
#define GUI_NAME	"Oreneta"


/**
	@author Pau Capella <pcapella@ac.upc.edu>
	@brief Oreneta plugin for NetMeter
*/
class NMGOreneta : public NMGModule
{
public:

	NMGOreneta();
	~NMGOreneta();

	void initModuleGUI();
	void removeModuleGUI();
	QWidget * getWidget();

private:

	NMGOrenetaWidget *m_orenetawidget;

};

NMMODULE_CLASS(MOD_CLASS)
NMMODULE_NAME((char *) MOD_NAME)
NMMODULE_CAPABILITIES((char *) MOD_CAPABILITIES)
NMMODULE_VERSION((char *) MOD_VERSION)
NMMODULE_GUINAME((char *) GUI_NAME)

#endif
