/***************************************************************************
 *   Copyright (C) 2005 by Ernest Nieto                                    *
 *   ernest.nieto@gmail.com                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef NMGORENETAWIDGET_H
#define NMGORENETAWIDGET_H

#include "nmgorenetawidgetbase.h"

#include <qstring.h>
#include <qpixmap.h>

class NMGOrenetaWidget: public NMGOrenetaWidgetBase {
Q_OBJECT
public:
    NMGOrenetaWidget(QWidget *parent = 0, const QString source = 0, const QString destination = 0, const char *name = 0);
private slots:
    virtual void setFilter();
private slots:
    virtual void addMeter();

    void deleteMeter();
    void infoHost();

    void setDirectionIn();
    void setDirectionOut();
    void setDirectionInOut();

private slots:
    virtual void showMeterMenu( QListViewItem *item, const QPoint&, int);

private:
	void addMeter(const int &id, const QString address);

	QString m_filter;

	QString m_source;
	QString m_destination;

	QPixmap m_in;
	QPixmap m_out;
	QPixmap m_inout;
};

#endif
