/***************************************************************************
 *   Copyright (C) 2005 by Rus Andrei Bogdan                                    *
 *   bogdanrus2004@yahoo.com                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef NMGSIMULATORWIDGET_H
#define NMGSIMULATORWIDGET_H

#include "../nmgisender.h"
#include "nmgsimulatorwidgetbase.h"

#include <qwidget.h>
#include <qlayout.h>
#include <qlineedit.h>
#include <qdom.h> 
#include <progressmanager.h>
#include <messagebar.h>
#include <qlineedit.h> 
#include <qpushbutton.h>
#include <qmessagebox.h>
#include <qlabel.h> 
#include <iostream>
#include <qstring.h> 
#include <qcombobox.h> 
#include <qlistview.h> 
#include <qspinbox.h> 
#include <qfiledialog.h> 
#include <qvalidator.h> 
#include <qradiobutton.h> 


class NMGSimulatorWidget : public NMGSimulatorWidgetBase {
Q_OBJECT
public:
    NMGSimulatorWidget(NMGISender * sender, QWidget *parent = 0, const char *name = 0);

    ~NMGSimulatorWidget();

	ProgressItem * progressItem;
	
	bool cleanInterface[100];


public slots:
    //here are the declarations of the slots 

	void addSource();
	void addNS();
	void addDestination();
	void addFlowSlot();
	void showFlowSlot(QListViewItem * item);
	void showItem(QListViewItem * itemShow);
	void delFlowSlot();
	void clearSlot();
	void saveSettingsSlot();
	void loadSettingsSlot();
	void connectSlot();
	void applySettingsSlot();
	void sendSettingsSlot();
	void nextSettingSlot(int indexSet);

	
   
    
private slots:
    //here are the declarations of the slots 
    //void actionSend();
		
	QString getDelaySlot(int currentIndex, QString netemMajor);
	QString getDDSlot(int currentIndex, QString netemMajor);
	void delayGroupChanged();
	void delayGroupChanged(QString value);
	void dDGroupChanged();
	void dDGroupChanged(QString value);
	QString returnDelayGroup();
	QString returnDDGroup();
	void l4ProtocolChanged(); 
	void l4ProtocolChanged(QString value);
  
    
private:
	QDomDocument doc;
	QDomElement root, router, settings;
	QString port, oldName, clean;
	
	NMGISender * sender;
	
};

#endif
