/***************************************************************************
 *   Copyright (C) 2005 by Ernest Nieto                                    *
 *   ernest.nieto@gmail.com                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "nmgsnooper.h"

NMMODULE_CLASS(MOD_CLASS)
NMMODULE_NAME((char *) MOD_NAME)
NMMODULE_CAPABILITIES((char *) MOD_CAPABILITIES)
NMMODULE_VERSION((char *) MOD_VERSION)
NMMODULE_GUINAME((char *) GUI_NAME)

NMGSnooper::NMGSnooper()
 : NMGModule()
{
	moduleName = MOD_NAME;
	moduleCapabilities = MOD_CAPABILITIES;
	moduleVersion = MOD_VERSION;
	moduleCoreMatching = CORE_MATCHING;
	moduleGUIName = GUI_NAME;
	m_snooperwidget = 0;
}


NMGSnooper::~NMGSnooper()
{
}

void NMGSnooper::initModuleGUI()
{
}

void NMGSnooper::removeModuleGUI()
{
	sendCommand(Stop, "");
}

QWidget *NMGSnooper::getWidget()
{
	if(!m_snooperwidget) m_snooperwidget = new NMGSnooperWidget(0, this, "Snooper");
	return m_snooperwidget;
	
}

void NMGSnooper::dataReceived(QString s)
{
	if(!m_snooperwidget) return;

	m_snooperwidget->resultReceived(s);	
}

void NMGSnooper::statusReceived(QString s)
{
	if(!m_snooperwidget) return;
	m_snooperwidget->statusReceived(s);
}


