/***************************************************************************
 *   Copyright (C) 2005 by Ernest Nieto                                    *
 *   ernest.nieto@gmail.com                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef NMGSNOOPERWIDGET_H
#define NMGSNOOPERWIDGET_H

#include "nmgsnooperwidgetbase.h"
#include "nmgsnooper.h"
#include <qmessagebox.h>
#include <qptrlist.h>
#include <qlistview.h>

class NMGSnooper;

class MemObject {

public:
	MemObject(const QString &name, const QString &parent);
	~MemObject();

	QString name() { return m_name; }
	QString parent() { return m_parent; }

private:
	QString m_name;
	QString m_parent;
};

class NMGSnooperWidget: public NMGSnopperWidgetBase {

Q_OBJECT
public:
	NMGSnooperWidget(QWidget *parent = 0, NMGSnooper *snooper = 0, const char *name = 0);

	void resultReceived(QString data);
	void statusReceived( QString data);

public slots:
	virtual void stopSnooper();
	virtual void startSnooper();

private:

	void showItems( QPtrList<MemObject> list);
	NMGSnooper *m_snooper;
	QMessageBox *m_message;
};

#endif
