/***************************************************************************
 *   Copyright (C) 2007 by Roberto Barreda                                 *
 *   rbarreda@ac.upc.edu                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "nmgstatistic.h"

#include <iostream>
using namespace std;

/**
 * Contructor of the class
 * @return 
 */
NMGStatistic::NMGStatistic()
{
	moduleName = MOD_NAME;
	moduleCapabilities = MOD_CAPABILITIES;
	moduleVersion = MOD_VERSION;
	moduleGUIName = GUI_NAME;
	widget=0;
}


/**
 * Destructor of the class
 * @return 
 */
NMGStatistic::~NMGStatistic()
{
}

void NMGStatistic::initModuleGUI()
{
}

void NMGStatistic::removeModuleGUI()
{
}

void NMGStatistic::createWidget()
{
	if(!widget) widget = new NMGStatisticWidget(&getPreferencesManager());
}

/**
 * Returns the widget associated to the module
 * @return 
 */
QWidget * NMGStatistic::getWidget()
{
	createWidget();
	return widget;
}
 
/**
 * Returns the popup menu associated to the module
 * @return 
 */
QPopupMenu * NMGStatistic::getPopupMenu()
{
	createWidget();
	return widget->getPopupMenu();
}


/**
 * Returns the toolbar associated to the module
 * @return 
 */
QToolBar * NMGStatistic::getToolBar()
{
	createWidget();
	return widget->getToolBar();
}
