/***************************************************************************
 *   Copyright (C) 2007 by Roberto Barreda                                 *
 *   rbarreda@ac.upc.edu                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef NMGStatisticFLOWDATA_H
#define NMGStatisticFLOWDATA_H

#include <qstring.h>
#include <qptrlist.h>

class NMGStatisticFlowData
{
	public:
		NMGStatisticFlowData();
		NMGStatisticFlowData ( NMGStatisticFlowData* );
		~NMGStatisticFlowData();

		void setId ( QString str_param );

		void setSentPackets(long long);
		void setDuplicatePackets(long long);
		void setLostPackets(long long);

		void setAverageDelay(double);
		void setMinDelay(double);
		void setMaxDelay(double);
		void setStDevDelay(double);
		void setJitterDelay(double);
		void setDelay99Percentile(double);
		void setDelay95Percentile(double);
		void setDelay999Percentile(double);
		void setDelay50Percentile(double);

		void setAverageIPDV(double);
		void setMinIPDV(double);
		void setMaxIPDV(double);
		void setStDevIPDV(double);
		void setJitterIPDV(double);
		void setIpdv99Percentile(double);
		void setIpdv95Percentile(double);
		void setIpdv999Percentile(double);
		void setIpdv50Percentile(double);

		QString getId();
		long long sentPackets();
		long long duplicatePackets();
		long long lostPackets();

		double averageDelay();
		double minDelay();
		double maxDelay();
		double stDevDelay();
		double jitterDelay();
		double delay99Percentile();
		double delay95Percentile();
		double delay999Percentile();
		double delay50Percentile();

		double averageIPDV();
		double minIPDV();
		double maxIPDV();
		double stDevIPDV();
		double jitterIPDV();
		double ipdv99Percentile();
		double ipdv95Percentile();
		double ipdv999Percentile();
		double ipdv50Percentile();

	private:
		QString m_str_id;
		long long sent, dupl, lost;
		double min_ipdv, max_ipdv, min_delay, max_delay;
		double avg_delay, avg_ipdv, stDev_delay, stDev_ipdv;
		double delay_jitter, ipdv_jitter, delay_percentile95, delay_percentile99, delay_percentile999;
		double delay_percentile50, ipdv_percentile50, ipdv_percentile95, ipdv_percentile99, ipdv_percentile999;
		
};

#endif
