/***************************************************************************
 *   Copyright (C) 2007 by Roberto Barreda                                 *
 *   rbarreda@ac.upc.edu                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "nmgstatisticflowmetadata.h"

#include <iostream>
using namespace std;

NMGStatisticFlowMetadata::NMGStatisticFlowMetadata()
{
	m_list_mod.setAutoDelete ( true );
	numPackets = -1;
}

NMGStatisticFlowMetadata::NMGStatisticFlowMetadata ( NMGStatisticFlowMetadata *fmd_flowMetadata )
{
	if ( fmd_flowMetadata )
	{
		m_str_name = fmd_flowMetadata->getName();
		m_str_id = fmd_flowMetadata->getId();
// 		m_str_dest = fmd_flowMetadata->getDest();
// 		m_str_size = fmd_flowMetadata->getSize();
// 		m_str_pattern = fmd_flowMetadata->getPattern();
		m_str_rate = fmd_flowMetadata->getRate();
		m_str_timeOn = fmd_flowMetadata->getTimeOn();
		m_str_timeOff = fmd_flowMetadata->getTimeOff();
		numPackets = fmd_flowMetadata->getNumPackets();
		m_list_mod = fmd_flowMetadata->getModList();
	}
}

NMGStatisticFlowMetadata::~NMGStatisticFlowMetadata()
{}

void NMGStatisticFlowMetadata::setName ( QString str_param )
{
	m_str_name = str_param;
}

void NMGStatisticFlowMetadata::setId ( QString str_param )
{
	m_str_id = str_param;
}

/*void NMGStatisticFlowMetadata::setDest(QString str_param)
{
	m_str_dest = str_param;
}

void NMGStatisticFlowMetadata::setSize(QString str_param)
{
	m_str_size = str_param;
}

void NMGStatisticFlowMetadata::setPattern(QString str_param)
{
	m_str_pattern = str_param;
}*/

void NMGStatisticFlowMetadata::setRate ( QString str_param )
{
	m_str_rate = str_param;
}

void NMGStatisticFlowMetadata::setTimeOn ( QString str_param )
{
	m_str_timeOn = str_param;
}

void NMGStatisticFlowMetadata::setTimeOff ( QString str_param )
{
	m_str_timeOff = str_param;
}

void NMGStatisticFlowMetadata::addModToList ( QString time, QString rate )
{
	m_list_mod.append ( new Mod(time, rate) );
}

QString NMGStatisticFlowMetadata::getName()
{
	return m_str_name;
}

QString NMGStatisticFlowMetadata::getId()
{
	return m_str_id;
}

/*QString NMGStatisticFlowMetadata::getDest()
{
	return m_str_dest;
}

QString NMGStatisticFlowMetadata::getSize()
{
	return m_str_size;
}

QString NMGStatisticFlowMetadata::getPattern()
{
	return m_str_pattern;
}*/

QString NMGStatisticFlowMetadata::getRate()
{
	return m_str_rate;
}

QString NMGStatisticFlowMetadata::getTimeOn()
{
	return m_str_timeOn;
}

QString NMGStatisticFlowMetadata::getTimeOff()
{
	return m_str_timeOff;
}

QPtrList<Mod> & NMGStatisticFlowMetadata::getModList()
{
	return m_list_mod;
}

long long NMGStatisticFlowMetadata::getNumPackets()
{
	if ( numPackets > 0 ) return numPackets;
	else
	{
		if ( m_list_mod.isEmpty() )
			numPackets = ( long long ) ( ( ( m_str_timeOff.toLongLong() - m_str_timeOn.toLongLong() ) * m_str_rate.toLongLong() ) /1000 );
		else
		{
			long long currentModRate, currentModTime;

			currentModTime = ((m_list_mod.at(0))->getTime()).toLongLong();
			currentModRate = ((m_list_mod.at(0))->getRate()).toLongLong();
			numPackets = ( long long ) ( ( currentModTime - m_str_timeOn.toLongLong() ) * m_str_rate.toLongLong() );

    			for ( uint i = 1; i < m_list_mod.count(); i++ ) {
				numPackets += ( long long ) ( ( (m_list_mod.at(i)->getTime()).toLongLong() - currentModTime ) * currentModRate );
				currentModTime = ((m_list_mod.at(i))->getTime()).toLongLong();
				currentModRate = ((m_list_mod.at(i))->getRate()).toLongLong();
			}
			numPackets += ( long long ) ( ( m_str_timeOff.toLongLong() - currentModTime ) * currentModRate );
			numPackets = ( long long ) numPackets / 1000;
		}
		return numPackets;
	}
}
