/***************************************************************************
 *   Copyright (C) 2007 by Roberto Barreda                                 *
 *   rbarreda@ac.upc.edu                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef NMGStatisticFLOWMETADATA_H
#define NMGStatisticFLOWMETADATA_H

#include <qstring.h>
#include <qptrlist.h>

class Mod
{
	public:
		Mod() : time ( 0 ), rate ( 0 ) { }
		Mod ( const QString& timeStr, const QString& rateStr )
				: time ( timeStr ), rate ( rateStr )
		{ }

		QString getTime() const { return time; }
		QString getRate() const { return rate; }

	private:
		QString time;
		QString rate;
};

class NMGStatisticFlowMetadata
{
	public:
		NMGStatisticFlowMetadata();
		NMGStatisticFlowMetadata ( NMGStatisticFlowMetadata* );
		~NMGStatisticFlowMetadata();

		void setName ( QString str_param );
		void setId ( QString str_param );
// 		void setDest ( QString str_param );
// 		void setSize ( QString str_param );
// 		void setPattern ( QString str_param );
		void setRate ( QString str_param );
		void setTimeOn ( QString str_param );
		void setTimeOff ( QString str_param );
		void addModToList ( QString time, QString rate );

		QString getName();
		QString getId();
		QString getDest();
		QString getSize();
		QString getPattern();
		QString getRate();
		QString getTimeOn();
		QString getTimeOff();
		QPtrList<Mod> & getModList();
		long long getNumPackets();

	protected:
		QString m_str_name;
		QString m_str_id;
// 		QString m_str_dest;
// 		QString m_str_size;
// 		QString m_str_pattern;
		QString m_str_rate;
		QString m_str_timeOn;
		QString m_str_timeOff;
		QPtrList<Mod> m_list_mod;
		long long numPackets;
		
};

#endif
