/***************************************************************************
 *   Copyright (C) 2007 by Roberto Barreda                                 *
 *   rbarreda@ac.upc.edu                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef NMGSTATISTICTHREAD_H
#define NMGSTATISTICTHREAD_H

#include "nmgstatisticxmlinterpret.h"
#include "nmgstatisticdata.h"

#include <nmthread.h>
#include <qstring.h>
#include <iostream>
using namespace std;


class NMGStatisticThread : public NMThread
{
	public:
		NMGStatisticThread();
		~NMGStatisticThread();

		enum NMGStatisticAppType {MGENAPP, NETPERFAPP};

		void loadFileName ( QString str_fileName );
		void kill();
		void run();
		bool isFinished();
		int getPercentCompleted();
		QString getStatus();
		//int getError();
		QString getErrorString();
		QString getFileNameResultXslt();

		void activateResultFile(bool act);
		bool isActivateResultFile();
	
		NMGStatisticData* getStatisticsData();

	private:
		void xsltConversion ( QString & fileName, QString & xsltPath, QString & fileNameResult );
		QString fileName;
		QString fileNameResultXslt;
		NMGStatisticXMLInterpret * interpret;

		bool activateResFile;
};

#endif

