/***************************************************************************
 *   Copyright (C) 2007 by Roberto Barreda                                 *
 *   rbarreda@ac.upc.edu                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef NMGSTATISTICWIDGET_H
#define NMGSTATISTICWIDGET_H

#include "nmgstatisticxmltags.h"

#include <qwidget.h>
#include <qpoint.h>
#include <qpopupmenu.h>
#include <qfiledialog.h>
#include <qtoolbar.h>

#include <progressmanager.h>
#include "nmgstatisticwidgetbase.h"
#include "nmgstatisticthread.h"
#include "../nmgimodulestationmanager.h"
#include "../nmgmodulepreferencesmanager.h"
// #include "../nmgimodulecommunication.h"
// #include "../nmgisender.h"
#include "../../gui/nmgxmlconfigurationfile.h"
#include "../../gui/nmgimagemanager.h"
#include "../nmgmodtabwidgetmanager.h"


class NMGStatisticWidget : public NMGStatisticWidgetBase
{
		Q_OBJECT
	public:
		NMGStatisticWidget ( NMGModulePreferencesManager * prefMan, QWidget *parent = 0, const char *name = 0 );
		~NMGStatisticWidget();

		QPopupMenu * getPopupMenu();
		QToolBar * getToolBar();

	public slots:
		void loadTestFromDisk();
		void loadStatisticsFromDisk();
		void exportStatisticsToXHTML();
		void exportStatisticsToTXT();
		void extractOtherStatisticsSN();
		void extractOtherStatisticsTS();
		QString getLastTestPath(bool isStatisticPath = false);
		void saveLastTestPathFromFilePath ( const QString & filePath, bool isStatisticPath = false );
		void loadCancelled ( ProgressItem * );
		void loadFinished ( ProgressItem * );
		void updateProgress();

	private:
		void xsltConversion ( QString & fileName, QString & xsltPath, QString & fileNameResult );

		void createListMenu();
		void updateWidgetBecauseOfTestEnd();

		QPopupMenu * listMenu;
		QToolBar * toolBar;
		NMGModulePreferencesManager * preferencesManager;
		ProgressItem * progressItem;
		QTimer * progressTimer;
		NMGStatisticThread * interpretThread;
};

#endif
