<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="xml" version='1.0' encoding="UTF-8" indent='yes' omit-xml-declaration="yes" />

<xsl:template match="test">
	<qt title="netperf" type="page">
	<font size="7"><strong><xsl:value-of select="metadata/name"/></strong></font><br />
	<font size="4"><strong>Identifier: </strong></font>
	<xsl:value-of select="metadata/identifier"/><br />
	<font size="4"><strong>Result Path: </strong></font>  
	<xsl:value-of select="metadata/result_path"/><br /><br />
	
	<font size="6"><strong>Source</strong></font> <br />
	<font size="4"><strong>Address: </strong></font><xsl:value-of select="metadata/source/address"/><br />
	<font size="4"><strong>Netperf Path: </strong></font><xsl:value-of select="metadata/source/netperf_path"/><br />
	<font size="4"><strong>Management Address: </strong></font><xsl:value-of select="metadata/source/management/address"/><br />
	<font size="4"><strong>Management Port: </strong></font> <xsl:value-of select="metadata/source/management/port"/><br /><br />
	
	<font size="6"><strong>Destination</strong></font><br />
	<font size="4"><strong>Address: </strong></font><xsl:value-of select="metadata/destination/address"/><br />
	<font size="4"><strong>Netserver Path: </strong></font><xsl:value-of select="metadata/destination/netserver_path"/><br />
	<font size="4"><strong>Management Address: </strong></font><xsl:value-of select="metadata/destination/management/address"/><br />
	<font size="4"><strong>Management Port: </strong></font> <xsl:value-of select="metadata/destination/management/port"/><br /><br />

	<xsl:for-each select="result/udp">
		<font size="7"><strong>Netperf (UDP Test)</strong></font><br />
		<strong>Source: </strong>
		<xsl:value-of select="source"/><br />
		<strong>Destination: </strong>
		<xsl:value-of select="destination"/><br /><br />
		<table border="1">
			<tr bgcolor="#9acd32">
				<th align="left">Send Socket Size (bytes)</th>
				<th align="left">Send Message Size (bytes)</th>
				<th align="left">Time (secs.)</th>
				<th align="left">#Send Message Ok</th>
				<th align="left">#Send Message Error</th>
				<th align="left">Send Throughput (10^3bits/sec)</th>
			</tr>
			<tr>
				<td><xsl:value-of select="sss"/></td>
				<td><xsl:value-of select="sms"/></td>
				<td><xsl:value-of select="time"/></td>
				<td><xsl:value-of select="send_mesg_ok"/></td>
				<td><xsl:value-of select="send_mesg_ko"/></td>
				<td><xsl:value-of select="send_throughput"/></td>
			</tr>
		</table>
		<br /> <br />
		<table border="1">
			<tr bgcolor="#9acd32">
				<th align="left">Recieved Socket Size (bytes)</th>
				<th align="left">#Received Message Ok</th>
				<th align="left">Received Throughput (10^3bits/sec)</th>
			</tr>
			<tr>
				<td><xsl:value-of select="rss"/></td>
				<td><xsl:value-of select="recv_mesg_ok"/></td>
				<td><xsl:value-of select="recv_throughput"/></td>
			</tr>
		</table>
	</xsl:for-each>
	<xsl:for-each select="result/tcp">
		<font size="7"><strong>Netperf (TCP Test)</strong></font><br />
		<strong>Source: </strong>
		<xsl:value-of select="source"/><br />
		<strong>Destination: </strong>
		<xsl:value-of select="destination"/><br /><br />
		<table border="1">
			<tr bgcolor="#9acd32">
				<th align="left">Send Socket Size (bytes)</th>
				<th align="left">Send Message Size (bytes)</th>
				<th align="left">Time (secs.)</th>
				<th align="left">Send Throughput (10^3bits/sec)</th>
			</tr>
			<tr>
				<td><xsl:value-of select="sss"/></td>
				<td><xsl:value-of select="sms"/></td>
				<td><xsl:value-of select="time"/></td>
				<td><xsl:value-of select="throughput"/></td>
			</tr>
		</table>
		<br /> <br />
		<table border="1">
			<tr bgcolor="#9acd32">
				<th align="left">Recieved Socket Size (bytes)</th>
			</tr>
			<tr>
				<td><xsl:value-of select="rss"/></td>
			</tr>
		</table>
	</xsl:for-each>
	</qt>
</xsl:template>

</xsl:stylesheet>