<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="text" version='1.0' encoding="UTF-8" omit-xml-declaration="yes" />

<xsl:template match="test">
	<xsl:text>*** </xsl:text><xsl:value-of select="metadata/name"/><xsl:text> *** </xsl:text>
	<xsl:text>
		Identifier: </xsl:text>
	<xsl:value-of select="metadata/identifier"/>
	<xsl:text>
		Mgen Version: </xsl:text><xsl:value-of select="metadata/mgen_version"/>
	<xsl:text>
		Result Path </xsl:text>  
	<xsl:value-of select="metadata/result_path"/>
	
	<xsl:text>
		
		Source</xsl:text>  
	<xsl:text>
			Address: </xsl:text><xsl:value-of select="metadata/source/address"/>
	<xsl:text>
			Mgen Path: </xsl:text><xsl:value-of select="metadata/source/mgen_path"/>
	<xsl:text>
			Management Address: </xsl:text><xsl:value-of select="metadata/source/management/address"/>
	<xsl:text>
			Management Port: </xsl:text> <xsl:value-of select="metadata/source/management/port"/>
	
	<xsl:text>
		
		Destination</xsl:text>  
	<xsl:text>
			Address: </xsl:text><xsl:value-of select="metadata/destination/address"/>
	<xsl:text>
			Drec Path: </xsl:text><xsl:value-of select="metadata/destination/drec_path"/>
	<xsl:text>
			Management Address: </xsl:text><xsl:value-of select="metadata/destination/management/address"/>
	<xsl:text>
			Management Port: </xsl:text> <xsl:value-of select="metadata/destination/management/port"/>
	
	<xsl:text>
		
		Statistics</xsl:text>
	<xsl:for-each select="statistics/flows/flow">
		<xsl:text>
			Flow ID: </xsl:text>
		<xsl:value-of select="@id"/><xsl:text> (</xsl:text><xsl:value-of select="@name"/><xsl:text>) </xsl:text>
		<xsl:text>
				Sent Packets: </xsl:text>
		<xsl:value-of select="sent"/>
		<xsl:text>
				Lost Packets: </xsl:text>
		<xsl:value-of select="lost"/>
		<xsl:text>
				Duplicated Packets: </xsl:text>
		<xsl:value-of select="duplicated"/>
<xsl:text>
			
CoS Related Metrics:
</xsl:text>
		<xsl:text>
Average IPTD	IPDV
----------------------
</xsl:text>
		<xsl:value-of select="delay/average"/><xsl:text>		</xsl:text>
		<xsl:value-of select="delay/p999 - delay/min"/><xsl:text>		</xsl:text>

		<xsl:text>
			
Delay statistics:
</xsl:text>
		<xsl:text>
Average Delay	Min Delay	Max Delay	StDev Delay	Jitter Delay	P.50 Delay	P.95 Delay	P.99 Delay	P.99'9 Delay
--------------------------------------------------------------------------------------------------------------------------------------------
</xsl:text>
		<xsl:value-of select="delay/average"/><xsl:text>		</xsl:text>
		<xsl:value-of select="delay/min"/><xsl:text>		</xsl:text>
		<xsl:value-of select="delay/max"/><xsl:text>		</xsl:text>
		<xsl:value-of select="delay/stdev"/><xsl:text>		</xsl:text>
		<xsl:value-of select="delay/jitter"/><xsl:text>		</xsl:text>
		<xsl:value-of select="delay/p50"/><xsl:text>		</xsl:text>
		<xsl:value-of select="delay/p95"/><xsl:text>		</xsl:text>
		<xsl:value-of select="delay/p99"/><xsl:text>		</xsl:text>
		<xsl:value-of select="delay/p999"/><xsl:text>		</xsl:text>

		<xsl:text>
			
IPDV statistics:
</xsl:text>
		<xsl:text>
Average IPDV	Min IPDV	Max IPDV	StDev IPDV	Jitter IPDV	P.50 IPDV	P.95 IPDV	P.99 IPDV	P.99'9 IPDV
--------------------------------------------------------------------------------------------------------------------------------------------
</xsl:text>
		<xsl:value-of select="ipdv/average"/><xsl:text>		</xsl:text>
		<xsl:value-of select="ipdv/min"/><xsl:text>		</xsl:text>
		<xsl:value-of select="ipdv/max"/><xsl:text>		</xsl:text>
		<xsl:value-of select="ipdv/stdev"/><xsl:text>	</xsl:text>
		<xsl:value-of select="ipdv/jitter"/><xsl:text>		</xsl:text>
		<xsl:value-of select="ipdv/p50"/><xsl:text>		</xsl:text>
		<xsl:value-of select="ipdv/p95"/><xsl:text>		</xsl:text>
		<xsl:value-of select="ipdv/p99"/><xsl:text>		</xsl:text>
		<xsl:value-of select="ipdv/p999"/><xsl:text>		</xsl:text>
		<xsl:text>
			
		</xsl:text>
		</xsl:for-each>
</xsl:template>
</xsl:stylesheet>