<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="html" version='1.0' encoding="UTF-8" indent='yes' omit-xml-declaration="yes" />

<xsl:template match="test">
	<html>
	<head><title><xsl:value-of select="metadata/name"/></title></head>
	<body>
		<font size="7"><strong><xsl:value-of select="metadata/name"/></strong></font><br />
		<font size="4"><strong>Identifier: </strong></font>
		<xsl:value-of select="metadata/identifier"/><br />
		<font size="4"><strong>Mgen Version: </strong></font><xsl:value-of select="metadata/mgen_version"/><br />
		<font size="4"><strong>Result Path: </strong></font>  
		<xsl:value-of select="metadata/result_path"/><br /><br />
		
		<font size="6"><strong>Source</strong></font> <br />
		<font size="4"><strong>Address: </strong></font><xsl:value-of select="metadata/source/address"/><br />
		<font size="4"><strong>Mgen Path: </strong></font><xsl:value-of select="metadata/source/mgen_path"/><br />
		<font size="4"><strong>Management Address: </strong></font><xsl:value-of select="metadata/source/management/address"/><br />
		<font size="4"><strong>Management Port: </strong></font> <xsl:value-of select="metadata/source/management/port"/><br /><br />
		
		<font size="6"><strong>Destination</strong></font><br />
		<font size="4"><strong>Address: </strong></font><xsl:value-of select="metadata/destination/address"/><br />
		<font size="4"><strong>Drec Path: </strong></font><xsl:value-of select="metadata/destination/drec_path"/><br />
		<font size="4"><strong>Management Address: </strong></font><xsl:value-of select="metadata/destination/management/address"/><br />
		<font size="4"><strong>Management Port: </strong></font> <xsl:value-of select="metadata/destination/management/port"/><br /><br />
		
		<font size="7"><strong>Statistics</strong></font><br />
		<xsl:for-each select="statistics/flows/flow">
			<font size="5"><strong>Flow ID: </strong></font>
			<xsl:value-of select="@id"/>
			<xsl:text> (</xsl:text><xsl:value-of select="@name"/><xsl:text>) </xsl:text>
			<br/><strong>Sent Packets: </strong>
			<xsl:value-of select="sent"/>
			<br/><strong>Lost Packets: </strong>
			<xsl:value-of select="lost"/>
			<br/><strong>Duplicated Packets: </strong>
			<xsl:value-of select="duplicated"/>
			<br/><br/><strong>CoS Related Metrics: </strong><br />
			<table border="1">
				<tr bgcolor="#9acd32">
					<th align="left">Average IPTD</th>
					<th align="left">IPDV</th>
				</tr>
				<tr>
					<td><xsl:value-of select="delay/average"/></td>
					<td><xsl:value-of select="delay/p999 - delay/min"/></td>
				</tr>
			</table>
			<br/><strong>Delay statistics: </strong><br />
			<table border="1">
				<tr bgcolor="#9acd32">
					<th align="left">Average Delay</th>
					<th align="left">Min Delay</th>
					<th align="left">Max Delay</th>
					<th align="left">StDev Delay</th>
					<th align="left">Jitter Delay</th>
					<th align="left">P.50 Delay</th>
					<th align="left">P.95 Delay</th>
					<th align="left">P.99 Delay</th>
					<th align="left">P.99'9 Delay</th>
				</tr>
				<tr>
					<td><xsl:value-of select="delay/average"/></td>
					<td><xsl:value-of select="delay/min"/></td>
					<td><xsl:value-of select="delay/max"/></td>
					<td><xsl:value-of select="delay/stdev"/></td>
					<td><xsl:value-of select="delay/jitter"/></td>
					<td><xsl:value-of select="delay/p50"/></td>
					<td><xsl:value-of select="delay/p95"/></td>
					<td><xsl:value-of select="delay/p99"/></td>
					<td><xsl:value-of select="delay/p999"/></td>
				</tr>
			</table>
			<br/><strong>IPDV statistics: </strong><br />
			<table border="1">
				<tr bgcolor="#9acd32">
					<th align="left">Average IPDV</th>
					<th align="left">Min IPDV</th>
					<th align="left">Max IPDV</th>
					<th align="left">StDev IPDV</th>
					<th align="left">Jitter IPDV</th>
					<th align="left">P.50 IPDV</th>
					<th align="left">P.95 IPDV</th>
					<th align="left">P.99 IPDV</th>
					<th align="left">P.99'9 IPDV</th>
				</tr>
				<tr>
					<td><xsl:value-of select="ipdv/average"/></td>
					<td><xsl:value-of select="ipdv/min"/></td>
					<td><xsl:value-of select="ipdv/max"/></td>
					<td><xsl:value-of select="ipdv/stdev"/></td>
					<td><xsl:value-of select="ipdv/jitter"/></td>
					<td><xsl:value-of select="ipdv/p50"/></td>
					<td><xsl:value-of select="ipdv/p95"/></td>
					<td><xsl:value-of select="ipdv/p99"/></td>
					<td><xsl:value-of select="ipdv/p999"/></td>
				</tr>
			</table>
			<br />
		</xsl:for-each>
	</body>
	</html>
</xsl:template>
</xsl:stylesheet>
