/***************************************************************************
 *   Copyright (C) 2005 by Ernest Nieto                                    *
 *   ernest.nieto@gmail.com                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef NMGTRACEWIDGET_H
#define NMGTRACEWIDGET_H

#include "nmgtracewidgetbase.h"
#include "nmgtrace.h"
#include "progressmanager.h"

#include <qstringlist.h>
#include <qtimer.h>

class NMGTrace;

class NMGTraceWidget: public NMGTraceWidgetBase {
Q_OBJECT
public:
	NMGTraceWidget( QWidget *parent = 0, NMGTrace *trace = 0, const char *name = 0);
	~NMGTraceWidget();

	void resultReceived( QString data);
	void statusReceived(QString data);
	void showHost( const int &pos, const QString &address, const QString &time);

signals:
	void send( QString value);

private slots:
	virtual void startTrace();
	void infoHostSource();
	void infoHostDestination();
	virtual void stopTrace();
	void slotProgressItemCanceled( ProgressItem *);

private:

	NMGTrace *m_trace;
	ProgressItem *m_progress;
};

#endif
