/***************************************************************************
 *   Copyright (C) 2005 by Ernest Nieto                                    *
 *   ernest.nieto@gmail.com                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef NMGMODULESUBSCRIPTIONLIST_H
#define NMGMODULESUBSCRIPTIONLIST_H

#include <nmgutil.h>

#include <qstring.h>
#include <qvaluelist.h>

typedef QValueList<QString> QSubscriptionList;
typedef QSubscriptionList::iterator QSubscriptionListIterator;
/**
* Manages the subscription to a module identified by moduleId
* The list contains the identifier of the modules subscripted
@author Ernest Nieto
*/
class NMGModuleSubscriptionList
{
public:
    NMGModuleSubscriptionList();

    NMGModuleSubscriptionList(QString id);
    
    ~NMGModuleSubscriptionList();

    QString getModuleId();
    
    void setModuleId(QString id);
        
    bool existsSubscription(QString id);
    
    void addSubscription(QString id);
    
    void removeSubscription(QString id);
 
    void notifyExecutedCommand(NMGCommandType commandType);
    
    QSubscriptionListIterator getBeginIterator();
    
    QSubscriptionListIterator getEndIterator();
    
private:
    QString moduleId;
    QSubscriptionList list;

};

#endif
