/***************************************************************************
 *   Copyright (C) 2005 by Ernest Nieto                                    *
 *   ernest.nieto@gmail.com                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "nmgsecuresendfilewidget.h"

#include "nmgsecuresendfilebasewidget.h"

#include "../../gui/widgets/nmghostinformationcombowidget.h"

#include <qlayout.h>
#include <qfiledialog.h>
#include <qlineedit.h>
#include <qpushbutton.h>


NMGSecureSendFileWidget::NMGSecureSendFileWidget(NMGISender * s, QWidget *parent, const char *name)
 : QWidget(parent, name)
{
	sender = s;
	
	QHBoxLayout * layout = new QHBoxLayout(this,0,0,"QHBoxLayoutMainWindow");
	widget = new NMGSecureSendFileBaseWidget(this);
	layout->addWidget(widget);
	
	connect(widget->buttonSelect,SIGNAL(clicked()),this,SLOT(buttonSelectClicked()));	
	connect(widget->buttonSend,SIGNAL(clicked()),this,SLOT(buttonSendClicked()));	
}


NMGSecureSendFileWidget::~NMGSecureSendFileWidget()
{
}

void NMGSecureSendFileWidget::buttonSelectClicked()
{
	QString file = QFileDialog::getOpenFileName (QString::null, QString::null, 0, 0,"Select file");
	if(file) widget->txtFile->setText(file);
	else widget->txtFile->setText("");
}

void NMGSecureSendFileWidget::buttonSendClicked()
{
	NMGHostInformationComboWidget * sc = widget->stationCombo;
	QString data = "<data>";
	data += "<host><address>"+sc->getStationAddressFromCombo()+"</address>";
	data += "<username>"+sc->getStationFromCombo()->getManagementUsername()+"</username>";
	data += "<password>"+sc->getStationFromCombo()->getManagementPassword()+"</password></host>";
	data += "<file>"+widget->txtFile->text() + "</file>";
	data += "<path>"+widget->txtRemotePath->text()+"</path></data>";
	
	sender->sendCommand(Start,data);
}



#include "nmgsecuresendfilewidget.moc"
